package puzzle;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.TreeMap;

import javax.imageio.ImageIO;

public class RunPuzzleSolver{
	
	private class AddCandidates implements Runnable{
		int minX,maxX,minY,maxY,i,partsNum,partsLeft;
		Integer finalPlacement[][];
		HashMap<Integer, Integer[]> chosenParts;
		ArrayList<TreeMap<Double, Integer[]>> nextToPlace;
		float confMatrix[][][];
		int bestBuddies[][];
		int bestBuddies2[][];
		boolean flag,useSize,missPart;
		int budddiesNumber[];
		PuzzleParts puzzleParts;

		public AddCandidates(int _minX,int _maxX,int _minY,int _maxY,int _i,int _partsNum,int _partsLeft,Integer _finalPlacement[][],
				HashMap<Integer, Integer[]> _chosenParts,ArrayList<TreeMap<Double, Integer[]>> _nextToPlace,float _confMatrix[][][],
				int _bestBuddies[][],boolean _flag,boolean _useSize,int _budddiesNumber[],PuzzleParts _puzzleParts,boolean _missPart,int _bestBuddies2[][]) {
			minX=_minX;maxX=_maxX;minY=_minY;maxY=_maxY;
			i=_i;
			partsNum=_partsNum;partsLeft=_partsLeft;
			finalPlacement=_finalPlacement;
			chosenParts=_chosenParts;
			nextToPlace=_nextToPlace;
			confMatrix=_confMatrix;
			bestBuddies=_bestBuddies;
			flag=_flag;
			useSize=_useSize;
			budddiesNumber=_budddiesNumber;
			puzzleParts=_puzzleParts;
			missPart=_missPart;
			bestBuddies2=_bestBuddies2;
		}

		@Override
		public void run() {
			for(int j=minX;j<maxX+1;j++){
				if(finalPlacement[i][j]!=null){
					if(finalPlacement[i-1][j]==null || finalPlacement[i+1][j]==null || finalPlacement[i][j-1]==null || finalPlacement[i][j+1]==null){
						if(flag)
							addBuddies(finalPlacement[i][j]-1);
						else
							addBuddies2(finalPlacement[i][j]-1);
					}
				}
			}
		}

		private void addBuddies(int nextI) {
			ArrayList<Orientation> ao=new ArrayList<Orientation>();
			ao.add(Orientation.DOWN);ao.add(Orientation.UP);ao.add(Orientation.LEFT);ao.add(Orientation.RIGHT);
			Collections.shuffle(ao);
			for(Orientation or:Orientation.values()){
				int next=bestBuddies[nextI][or.ordinal()];
				//			if(puzzleParts.isBurn(next) && partsLeft>puzzleParts.burnPartsNum+2)
				//				continue;
				if(next==-1)
					continue;
				int op=(or.ordinal()%2==0)?(or.ordinal()+1):(or.ordinal()-1);
				//			int count=-1;
				//			Double val=confMatrix[next][nextI][op];
				//			if(val>confMatrix[next][bestBuddies[next][0]][0])
				//				count++;
				//			if(val>confMatrix[next][bestBuddies[next][1]][1])
				//				count++;
				//			if(val>confMatrix[next][bestBuddies[next][2]][2])
				//				count++;
				//			if(val>confMatrix[next][bestBuddies[next][3]][3])
				//				count++;
				//			if(count>2)
				//				continue;
				Integer nextA[]=new Integer[3];
				nextA[0]=next;
				int dir[]=new int[3];
				if(nextI==bestBuddies[next][op]  && !chosenParts.containsKey(next)){ //&&
					//!nextToPlace.get(budddiesNumber[next]-1).containsKey(bestBuddiesTree.get(budddiesNumber[next]-1).get(next))){
					switch(or){
					case UP:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]-1;
						dir[0]=3;
						dir[1]=1;
						dir[2]=2;
						break;
					case DOWN:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]+1;
						dir[0]=2;
						dir[1]=0;
						dir[2]=3;
						break;
					case LEFT:
						nextA[1]=chosenParts.get(nextI)[0]-1;
						nextA[2]=chosenParts.get(nextI)[1];
						dir[0]=0;
						dir[1]=3;
						dir[2]=1;
						break;
					case RIGHT:
						nextA[1]=chosenParts.get(nextI)[0]+1;
						nextA[2]=chosenParts.get(nextI)[1];
						dir[0]=1;
						dir[1]=2;
						dir[2]=0;
						break;
					default:
						break;
					}
					if((useSize && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
							nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
						continue;
//					if(nextA[1]>partsNum/2-2|| nextA[1]<0 ||
//							nextA[0]>partsNum/2-2|| nextA[0]<0)
//						continue;
					int flagc=0;
					double w1=0.5,w2=0.5;
					//				if(partsLeft<partsNum/16){
					//					w1=0.25;
					//					w2=0.75;
					//				}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
						flagc++;                
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					} 
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
					    flagc++;
					}

					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][0]==finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null  && bestBuddies[nextA[0]][2]==finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1) {
					    flagc++;
					}   			
					double th2=0;
					int flagc2=0;
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[1][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[0][nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[0][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[1][nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
						th2+=w1*confMatrix[3][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]]+w2*confMatrix[2][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
						th2+=w1*confMatrix[2][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]]+w2*confMatrix[3][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1];
						flagc2++;
					}
					//				if(flagc2==1 && 
					//						(bestBuddies[next][dir[0]]!=-1 && bestBuddies[bestBuddies[next][dir[0]]][dir[1]]!=-1
					//						&& bestBuddies[bestBuddies[bestBuddies[next][dir[0]]][dir[1]]][dir[2]]!=nextI)// &&
					//(bestBuddies[next][dir[2]]!=-1 && bestBuddies[bestBuddies[next][dir[2]]][dir[1]]!=-1
					//&& bestBuddies[bestBuddies[bestBuddies[next][dir[2]]][dir[1]]][dir[0]]!=nextI))
					//						) 
					//					continue;
					double add=((flagc-1)>0)?(flagc-1):0;
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
						synchronized (nextToPlace){	
							if(!missPart)
								nextToPlace.get(12).put(th2/flagc2+flagc2*0.0+add*0.3,nextA);
							else
								nextToPlace.get(12).put(th2/flagc2,nextA);
						}
					}
				}
			}
		}

		private void addBuddies2(int nextI) {
			ArrayList<Orientation> ao=new ArrayList<Orientation>();
			ao.add(Orientation.DOWN);ao.add(Orientation.UP);ao.add(Orientation.LEFT);ao.add(Orientation.RIGHT);
			Collections.shuffle(ao);
			for(Orientation or:Orientation.values()){
				int next=bestBuddies[nextI][or.ordinal()];
				//			if(puzzleParts.isBurn(next) && partsLeft>puzzleParts.burnPartsNum+2)
				//				continue;
				if(next==-1)
					continue;
				Integer nextA[]=new Integer[3];
				nextA[0]=next;
				int op=(or.ordinal()%2==0)?(or.ordinal()+1):(or.ordinal()-1);
				//			Double val=confMatrix[nextI][next][or.ordinal()]/2+confMatrix[next][nextI][op]/2;
				//			Double val=confMatrix[next][nextI][op];
				//			if(val<0.368) continue;
				//			int count=0;
				//			Double val=confMatrix[next][nextI][op];
				//			if(val<confMatrix[next][bestBuddies[next][0]][0])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][1]][1])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][2]][2])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][3]][3])
				//				count++;
				//			if(count>2)
				//				continue;
				if(!chosenParts.containsKey(next)){ //&&
					switch(or){
					case UP:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]-1;
						break;
					case DOWN:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]+1;
						break;
					case LEFT:
						nextA[1]=chosenParts.get(nextI)[0]-1;
						nextA[2]=chosenParts.get(nextI)[1];
						break;
					case RIGHT:
						nextA[1]=chosenParts.get(nextI)[0]+1;
						nextA[2]=chosenParts.get(nextI)[1];
						break;
					default:
						break;
					}
					if((useSize && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
							nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
						continue;
//					if(nextA[1]>partsNum/2-2|| nextA[1]<0 ||
//							nextA[0]>partsNum/2-2|| nextA[0]<0)
//						continue;
					int flagc=0;
					double w1=0.5,w2=0.5;
					//				if(partsLeft<partsNum/16){
					//					w1=0.25;
					//					w2=0.75;
					//				}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
						flagc++;                
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					} 
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
					    flagc++;
					}

					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][0]==finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null  && bestBuddies[nextA[0]][2]==finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1) {
					    flagc++;
					}   			
					double th2=0,maxTh=0;
					int flagc2=0;
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[1][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[0][nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][1]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][0]);
						flagc2++;
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[0][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[1][nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][0]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][1]);
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
						th2+=w1*confMatrix[3][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]]+w2*confMatrix[2][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]][3]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][2]);
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
						th2+=w1*confMatrix[2][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]]+w2*confMatrix[3][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]][2]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][3]);
						flagc2++;
					}
					//				if(val<0.369 && flagc2==1) continue;
					double add=((flagc-1)>0)?(flagc-1):0;
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
						synchronized (nextToPlace){	
							if(!missPart)
								try{
									nextToPlace.get(12).put(th2/flagc2+flagc2*0.5+add*0.3,nextA);
								}
							catch (Exception e) {
								System.out.println("E"+flagc2);
							}
							else
								nextToPlace.get(12).put(th2/flagc2/*+maxTh/2*/,nextA);
						}
					}
				}
				//			next=bestBuddies2[nextI][or.ordinal()];
				//			if(next==-1)
				//				continue;
				//			nextA=new Integer[3];
				//			nextA[0]=next;
				//			if(!chosenParts.containsKey(next)){ //&&
				//				switch(or){
				//				case UP:
				//					nextA[1]=chosenParts.get(nextI)[0];
				//					nextA[2]=chosenParts.get(nextI)[1]-1;
				//					break;
				//				case DOWN:
				//					nextA[1]=chosenParts.get(nextI)[0];
				//					nextA[2]=chosenParts.get(nextI)[1]+1;
				//					break;
				//				case LEFT:
				//					nextA[1]=chosenParts.get(nextI)[0]-1;
				//					nextA[2]=chosenParts.get(nextI)[1];
				//					break;
				//				case RIGHT:
				//					nextA[1]=chosenParts.get(nextI)[0]+1;
				//					nextA[2]=chosenParts.get(nextI)[1];
				//					break;
				//				default:
				//					break;
				//				}
				//				if((useSize && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
				//						nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
				//				 continue;
				//				int flagc=0;
				//				double w1=0.5,w2=0.5;
				//				if(partsLeft<partsNum/4){
				//					w1=0.25;
				//					w2=0.75;
				//				}
				//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
				//					flagc++;
				//				}
				//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null  && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
				//					flagc++;
				//				}			
				//				double th2=0,maxTh=0;
				//				int flagc2=0;
				//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][1]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][0];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][1]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][0]);
				//					flagc2++;
				//				}
				//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][0]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][1];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][0]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][1]);
				//					flagc2++;
				//				}
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]][3]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][2];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]][3]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][2]);
				//					flagc2++;
				//				}
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]][2]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][3];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]][2]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][3]);
				//					flagc2++;
				//				}
				//				double add=((flagc-1)>0)?(flagc-1):0;
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
				//					if(!missPart)
				//						try{
				//							nextToPlace.get(12).put(th2/flagc2+flagc2*0.00+add*0.3,nextA);
				//						}
				//					catch (Exception e) {
				//						System.out.println("E"+flagc2);
				//					}
				//					else
				//						nextToPlace.get(12).put(th2/flagc2/*+maxTh/2*/,nextA);
				//				}
				//			}
			}
		}

	}
	
	private class CalcConfMatrix implements Runnable{

		Orientation or;
		int i,partSize,partsNum,partsLeft;
		float diffMatrix[][][];
		float confMatrix[][][];
		int bestBuddies[][];
		int bestBuddies2[][];
		PuzzleParts puzzleParts;
		boolean missPart;
		HashMap<Integer, Integer[]> chosenParts;

		public CalcConfMatrix(float[][][] diffMatrix2,float _confMatrix[][][],int _bestBuddies[][],int _partSize,int _partsNum,int _partsLeft,Orientation _or, PuzzleParts _puzzleParts,boolean _missPart, HashMap<Integer, Integer[]> _chosenParts,int _bestBuddies2[][]) {
			or=_or;
			partSize=_partSize;
			partsNum=_partsNum;
			partsLeft=_partsLeft;
			diffMatrix=diffMatrix2;
			confMatrix=_confMatrix;
			bestBuddies=_bestBuddies;
			puzzleParts=_puzzleParts;
			missPart=_missPart;
			chosenParts=_chosenParts;
			bestBuddies2=_bestBuddies2;
		}

		private Float[] getRow(float[][][] diffMatrix2, int i, Orientation or,int k) {
			Float[] row=new Float[partsNum];
			for(int j=0;j<partsNum;j++){
				row[j]=diffMatrix2[or.ordinal()][i][j];
			}
			return row;
		}

		@Override
		public void run() {
			int op=(or.ordinal()%2==0)?(or.ordinal()+1):(or.ordinal()-1);
			List<Integer> A=new ArrayList<Integer>();
			List<Integer> A2=new ArrayList<Integer>();
//			for(int i=0;i<partsNum;i++){
//				if(chosenParts.containsKey(i))
//					A.add(i);
//			}
			for(int i=0;i<partsNum;i++){
				if(!chosenParts.containsKey(i))
					A.add(i);
			}
			Collections.shuffle(A);
//			A.addAll(A2);
			for(int i=0;i<partsNum;i++){
				bestBuddies[i][or.ordinal()]=-1;
//				bestBuddies2[i][or.ordinal()]=0;
				//			if(puzzleParts.isEmpty(i)){
				//				for(int j=0;j<partsNum;j++){
				//					confMatrix[i][j][or.ordinal()]=Math.exp(-10);
				//				}
				//				continue;

				TreeMap<Float,Integer> tm=new TreeMap<Float,Integer>();
//				Double[] row=getRow(diffMatrix,i,or,0);
				Float[] row2=getRow(diffMatrix,i,or,0);
//				ArrayList<Double> rowList=new ArrayList<Double>(Arrays.asList(row));
				ArrayList<Float> rowList2=new ArrayList<Float>(Arrays.asList(row2));
//				Collections.sort(rowList);
//				Collections.sort(rowList2);
				Float tmp_min=Collections.min(rowList2);
				rowList2.remove(tmp_min);
//				double s2=rowList.get(1);
//				float s2_2=rowList2.get(1);
				float s2_2=tmp_min;
//				if(s2_2>0)
					s2_2=Collections.min(rowList2);
//				else
//					System.out.println("Bla");
				
//				double s20=rowList.get(19);
//				double s1=rowList.get(0);
				//			if(missPart)
				//				s2=rowList.get(partsNum/8);
//							System.out.println("S1: "+s1+" || S2: "+s2);
//				if(s2_2>=0 && s2_2<5000)
//					System.out.println("S2: "+s2_2);
				if (partsLeft<2)
					s2_2=10000;//5

				for(int jj=0;jj<A.size();jj++){
					int j=A.get((jj+i*3)%A.size());
					//					if((!puzzleParts.isBurn(i) && puzzleParts.isBurn(j)) || (puzzleParts.isBurn(i) && !puzzleParts.isBurn(j))){
					//						confMatrix[i][j][or.ordinal()]=0;
					////						System.out.println("D: "+diffMatrix[i][j][or.ordinal()]);
					//					}
					if(s2_2!=0){
						confMatrix[or.ordinal()][i][j]=1-diffMatrix[or.ordinal()][i][j]/s2_2;//Math.exp(-diffMatrix[0][i][j][or.ordinal()]/s2_2);
//						if(puzzleParts.isLowEnt(i) && puzzleParts.isNLowEnt(j) || (puzzleParts.isLowEnt(j) && puzzleParts.isNLowEnt(i)))
//							confMatrix[i][j][or.ordinal()]=0;
					}
					else /*if(diffMatrix[0][i][j][or.ordinal()]==0)*/{
						confMatrix[or.ordinal()][i][j]=(float) 0.001;//Math.exp(-1);
						if(partsLeft<2*puzzleParts.burnPartsNum || partsLeft<2*puzzleParts.darkPartsNum)
							confMatrix[or.ordinal()][i][j]=(float) 0.5;//Math.exp(-0.5);	
					}
					if(diffMatrix[or.ordinal()][i][j]>1000 && confMatrix[or.ordinal()][i][j]>0)
						confMatrix[or.ordinal()][i][j]=confMatrix[or.ordinal()][i][j]/10000;
					if(missPart && (puzzleParts.isEmpty(i) || puzzleParts.isEmpty(j)))
						confMatrix[or.ordinal()][i][j]=0;//Math.exp(-10);
//					if(partsLeft<partsNum/5 && s1>3.9)
//						confMatrix[i][j][or.ordinal()]=Math.exp(-diffMatrix[i][j][or.ordinal()]*(2/s2));
//					if(((s1>0 && s1==s2)  || (chosenParts.containsKey(i) && chosenParts.containsKey(j))) && s2!=5){//diffMatrix[i][j][or.ordinal()]>4.2 || 
//						confMatrix[i][j][or.ordinal()]=0;
//					}
//					if(puzzleParts.isBurn(i) && puzzleParts.isBurn(j))
//						confMatrix[i][j][or.ordinal()]=Math.exp(-1);
//					if(partsLeft>50 && s1>0 && s1/s20 < 0.7){
////						System.out.println("*"+(s1/s20));
//						confMatrix[i][j][or.ordinal()]=confMatrix[i][j][or.ordinal()]*1.1;
//					}
//					System.out.println("S1:"+s1+" || S2:"+s2+" || Comp: " + confMatrix[i][j][or.ordinal()]);
//					if(!(chosenParts.containsKey(i) && chosenParts.containsKey(j)) && confMatrix[or.ordinal()][i][j]>0)
						tm.put(confMatrix[or.ordinal()][i][j], j);
				}

				Iterator<Integer> ordIt=tm.descendingMap().values().iterator();
//				Iterator<Float> ordItK = tm.descendingMap().keySet().iterator();
				//			synchronized (bestBuddies) {
//				if(ordItK.next()>0)
				if(ordIt.hasNext())
					bestBuddies[i][or.ordinal()]=ordIt.next();
//				if(ordIt.hasNext())
//					if(ordItK.next()>0)
//						bestBuddies2[i][or.ordinal()]=ordIt.next();
					
				//				else
				//					System.out.println("*");
				//			}
			}
		}
	}

	private class CalcDiff implements Runnable{
		PuzzleParts puzzleParts;
		Orientation or;
		int ii,jj,partSize,partsNum;
		float diffMatrix[][][];
		int itNum;

		public CalcDiff(float[][][] diffMatrix2,int _partSize,int _partsNum,PuzzleParts _puzzleParts,Orientation _or, int _i, int _j,int _itNum) {
			puzzleParts=_puzzleParts;
			or=_or;
			ii=_i;
			jj=_j;
			partSize=_partSize;
			partsNum=_partsNum;
			diffMatrix=diffMatrix2;
			itNum=_itNum;
		}


		@Override
		public void run() {
			for(int i=ii;i<ii+itNum+1&&i<partsNum;i++){
				PuzzlePart p1=puzzleParts.getLABPart(i);
				LABVector p1_l1 = null;
				LABVector p1_l2 = null;
				LABVector p1_l3 = null;
				LABVector p2_l1 = null;
				LABVector p2_l2 = null;
				LABVector p2_l3 = null;
				switch(or){
				case DOWN:
					p1_l1 = p1.getRow(partSize-1);
					p1_l2 = p1.getRow(partSize-2);
					p1_l3 = p1.getRow(partSize-3);
					break;
				case RIGHT:			
					p1_l1 = p1.getCol(partSize-1);
					p1_l2 = p1.getCol(partSize-2);
					p1_l3 = p1.getCol(partSize-3);
					break;
				case LEFT:
					p1_l1 = p1.getCol(0);
					p1_l2 = p1.getCol(1);
					p1_l3 = p1.getCol(2);
					break;
				case UP:
					p1_l1 = p1.getRow(0);
					p1_l2 = p1.getRow(1);
					p1_l3 = p1.getRow(2);
					break;
				default:
					break;
				}
				//		int start=updown*partsNum/2,finish=(1+updown)*partsNum/2;
				//		if(op==1){
				//			start=0;finish=partsNum;
				//		}
				for(int j=jj;j<jj+itNum+1&&j<partsNum;j++){

					int op=or.ordinal()+1;
					double diffB;
					if((!puzzleParts.isDark(i)) && (!puzzleParts.isDark(j))){
						
						double Ri=puzzleParts.avgBorder[0][or.ordinal()][i];
						double Gi=puzzleParts.avgBorder[1][or.ordinal()][i];
						double Bi=puzzleParts.avgBorder[2][or.ordinal()][i];
						double Rj=puzzleParts.avgBorder[0][op][j];
						double Gj=puzzleParts.avgBorder[1][op][j];
						double Bj=puzzleParts.avgBorder[2][op][j];
						 diffB=(Ri-Rj)*(Ri-Rj)+(Gi-Gj)*(Gi-Gj)+(Bi-Bj)*(Bi-Bj);
					}
					else
						diffB=1000;
					if(diffB<300){

//									if(puzzleParts.isEmpty(j)){
//										diffMatrix[i][j][or.ordinal()]=Double.MAX_VALUE;
//										diffMatrix[j][i][op]=Double.MAX_VALUE;
//										continue;
//									}
						float /*diff11=0, diff12=0,*/diff21=0, diff22=0;//,diff1=0,diff2=0;
						PuzzlePart p2=puzzleParts.getLABPart(j);
						switch(or){
						case DOWN:
							p2_l1 = p2.getRow(0);
							p2_l2 = p2.getRow(1);
							p2_l3 = p2.getRow(2);
							break;
						case RIGHT:			
							p2_l1 = p2.getCol(0);
							p2_l2 = p2.getCol(1);
							p2_l3 = p2.getCol(2);
							break;
						case LEFT:
							p2_l1 = p2.getCol(partSize+1);
							p2_l2 = p2.getCol(partSize);
							p2_l3 = p2.getCol(partSize-1);
							break;
						case UP:
							p2_l1 = p2.getRow(partSize+1);
							p2_l2 = p2.getRow(partSize);
							p2_l3 = p2.getRow(partSize-1);
							break;
						default:
							break;
						}
//						diff21=(float) MGC.calc(p1_l2, p1_l3, p2_l2, p2_l3)+MGC.calc(p2_l2, p2_l3, p1_l2, p1_l3);
//						diff22=(float) diff21;
						diff21=(float) p1_l1.sub(p2_l2).abs().sum();//3.0/10.0.pow(1)
						diff22=(float) p2_l1.sub(p1_l2).abs().sum();//3.0/10.0
//						diff21=(float) p1_l2.sub(p2_l2).abs().pow(2).sum();
//						diff21=(float) p1_l1.sub(p2_l2).abs().pow(3.0/10.0).sum();//3.0/10.0.pow(1)
//						diff22=(float) p2_l1.sub(p1_l2).abs().pow(3.0/10.0).sum();//3.0/10.0
						//				diff21=(float) p1_l1.sub(p1_l2).add(p1_l1).sub(p2_l1).abs().pow(3.0/10.0).sum();//3.0/10.0.pow(1)
						//				diff22=(float) p2_l1.sub(p2_l2).add(p2_l1).sub(p1_l1).abs().pow(3.0/10.0).sum();//3.0/10.0
						//			diff11=p1_l1.sub(p2_l1).abs().sum();//3.0/10.0
						//			diff12=p2_l1.sub(p1_l1).abs().pow(3.0/10.0).sum();//3.0/10.0
						//			diff1=diff11;//Math.pow(diff11, 5.0/48.0);//+Math.pow(diff12, 5.0/48.0);
						//			System.out.println("Comp: D="+diff1+" G="+(Math.abs(p1_l1.avgGrad()-p2_l1.avgGrad())));
						//			diff2=Math.pow(diff21, 5.0/48.0)+Math.pow(diff22, 5.0/48.0);
						//			diffMatrix[i][j][or.ordinal()]=diff1/2+diff2/2;//Math.min(diff1,diff2);
						//			diffMatrix[j][i][op]=diff1/2+diff2/2;//Math.min(diff1,diff2);
						//			diffMatrix[i][j][or.ordinal()]=diff1+diff21;//Math.pow(diff21, 5.0/48.0);//Math.min(diff1,diff2);
						//			diffMatrix[j][i][op]=diff1+diff22;//Math.pow(diff22, 5.0/48.0);//Math.min(diff1,diff2);
						//			diffMatrix[0][i][j][or.ordinal()]=diff1;
						//			diffMatrix[0][j][i][op]=diff1;
						//				diffMatrix[or.ordinal()][i][j]=(float) Math.pow(diff21,5.0/48.0);//Math.pow(diff21,0.1);
						//				diffMatrix[op][j][i]=(float) Math.pow(diff22,5.0/48.0);//Math.pow(diff22,0.1);
						diffMatrix[or.ordinal()][i][j]=diff21;
						diffMatrix[op][j][i]=diff22;
//						diffMatrix[or.ordinal()][i][j]=(float) Math.pow((diff21+diff22),3.0/24.0);
//						diffMatrix[op][j][i]=diffMatrix[or.ordinal()][i][j];
						//				diff21=MGC.calc(p1_l1, p1_l2, p2_l1, p2_l2);
						//				diff22=MGC.calc(p2_l1, p2_l2, p1_l1, p1_l2);
						//				diffMatrix[or.ordinal()][i][j]=diff21+diff22;
						//				diffMatrix[op][j][i]=diff21+diff22;
						//			System.out.println("d1:"+diff1+" || d2:"+diff2/2);
						if(i==j){
							diffMatrix[or.ordinal()][i][j]=Float.MAX_VALUE;
							diffMatrix[op][j][i]=Float.MAX_VALUE;
							//				diffMatrix[1][i][j][or.ordinal()]=Double.MAX_VALUE;
							//				diffMatrix[1][j][i][op]=Double.MAX_VALUE;
						}
					}
					else{
						diffMatrix[or.ordinal()][i][j]=Float.MAX_VALUE;
						diffMatrix[op][j][i]=Float.MAX_VALUE;
					}
				}
			}
		}
	}

	private static class ConvColor {
		public static void rgb2lab(int R, int G, int B, double []lab) {
			//http://www.brucelindbloom.com
			  
			float r, g, b, X, Y, Z, fx, fy, fz, xr, yr, zr;
			float Ls, as, bs;
			float eps = 216.f/24389.f;
			float k = 24389.f/27.f;
			   
			float Xr = 0.964221f;  // reference white D50
			float Yr = 1.0f;
			float Zr = 0.825211f;
			
			// RGB to XYZ
			r = R/255.f; //R 0..1
			g = G/255.f; //G 0..1
			b = B/255.f; //B 0..1
			
			// assuming sRGB (D65)
			if (r <= 0.04045)
				r = r/12;
			else
				r = (float) Math.pow((r+0.055)/1.055,2.4);
			
			if (g <= 0.04045)
				g = g/12;
			else
				g = (float) Math.pow((g+0.055)/1.055,2.4);
			
			if (b <= 0.04045)
				b = b/12;
			else
				b = (float) Math.pow((b+0.055)/1.055,2.4);
			
			
			X =  0.436052025f*r     + 0.385081593f*g + 0.143087414f *b;
			Y =  0.222491598f*r     + 0.71688606f *g + 0.060621486f *b;
			Z =  0.013929122f*r     + 0.097097002f*g + 0.71418547f  *b;
			
			// XYZ to Lab
			xr = X/Xr;
			yr = Y/Yr;
			zr = Z/Zr;
					
			if ( xr > eps )
				fx =  (float) Math.pow(xr, 1/3.);
			else
				fx = (float) ((k * xr + 16.) / 116.);
			 
			if ( yr > eps )
				fy =  (float) Math.pow(yr, 1/3.);
			else
			fy = (float) ((k * yr + 16.) / 116.);
			
			if ( zr > eps )
				fz =  (float) Math.pow(zr, 1/3.);
			else
				fz = (float) ((k * zr + 16.) / 116);
			
			Ls = ( 116 * fy ) - 16;
			as = 500*(fx-fy);
			bs = 200*(fy-fz);
			
			lab[0] = ((2.55*Ls + .5)/255.0*100.0);//*65280
			lab[1] = (((as + .5)+128)/255.0*255.0);//*65280
			lab[2] = (((bs + .5)+128)/255.0*255.0);//*65280
		
		} 
		
		public static void main(String[] args) {
			double lab[]=new double[3];
			ConvColor.rgb2lab(0,0,0,lab);
			System.out.println(lab[0]+" "+lab[1]+" "+lab[2]);
			ConvColor.rgb2lab(255,255,255,lab);
			System.out.println(lab[0]+" "+lab[1]+" "+lab[2]);
			
		}
	}
	
	private class EliminateComp  implements Runnable{
		
		int i,partsNum;
		double diffMatrix[][][];
		HashMap<Integer, Integer[]> chosenParts;
		
		public EliminateComp(double _diffMatrix[][][],HashMap<Integer, Integer[]> _chosenParts,int _partsNum,int _i) {
			 diffMatrix=_diffMatrix;
			 partsNum=_partsNum;
			 i=_i;
			 chosenParts=_chosenParts;
		}
		
		@Override
		public void run() {
			for(int j=0;j<partsNum;j++){
				if(chosenParts.containsKey(i) && chosenParts.containsKey(j)){
					diffMatrix[i][j][0]=Double.MAX_VALUE;
					diffMatrix[i][j][1]=Double.MAX_VALUE;
					diffMatrix[i][j][2]=Double.MAX_VALUE;
					diffMatrix[i][j][3]=Double.MAX_VALUE;
				}
			}
		}

	}

	private class GeneratePuzzle {

		String inputFile, outputFile;
		BufferedImage img,nimg;
		int size, h, w, nh, nw,borderNum;
		boolean sh;
		int type;
		Random rnd=new Random();


		public GeneratePuzzle(String _inputFile, String _outputFile, int _size,boolean _sh,int _type) throws IOException {
			inputFile=_inputFile;
			outputFile=_outputFile;
			size=_size;
			img=ImageIO.read(new File(_inputFile));
			h=img.getHeight();
			w=img.getWidth();
			nh=h/size;
			nw=w/size;
			sh=_sh;
			type=_type;
			createOutput();
			img=null;
		}

		private void createOutput() throws IOException {
			nimg=new BufferedImage(w, h,BufferedImage.TYPE_INT_RGB);
			int findBorder[][]=new int[nh][nw];
			int count=0;
			borderNum=0;
			ArrayList<Integer> rnadIdx = new ArrayList<Integer>();
			for(int i=0;i<nh*nw;i++){
				rnadIdx.add(i);
			}
			if(sh)
				Collections.shuffle(rnadIdx);
			//		System.out.println(type);
			int start = 0;
			if(type==2)
				start=18;
			if(type==3)
				start=2;
			for(int i=0;i<nh*nw;i++){
				findBorder[i/nw][i%nw]=0;
				int ii=Math.abs(i/nw-nh/2);
				int jj=Math.abs(i%nw-nw/2);
				double r=Math.pow(ii, 2)+Math.pow(jj, 2);
//				System.out.println(ii+","+jj);
				if(type==0 || /*(type==1 && i%20!=5)*/(type==1 && rnd.nextFloat()<0.9) ||
						(type==2 && (i/nw%5!=4 || i%nw<start/6 || i%nw>start/6+5)) ||
						(type==3 && (i%nw%5!=4 || i/nw<start || i/nw>start+5)) ||
						(type==4 && 
						(((i/nw>4 && i/nw<nh-5) || (i%nw>4 && i%nw<nw-5)) || ((i/nw==4 || i/nw==nh-5) && (i%nw==4 || i%nw==nw-5))
								|| ((i/nw==3 || i/nw==nh-4) && (i%nw==4 || i%nw==nw-5))|| ((i/nw==4 || i/nw==nh-5) && (i%nw==3 || i%nw==nw-4)))) ||
								(type==5 && r<nh*nh/4) ||
								(type==6 && r>nh*nh/8) ||
								(type==7 && r>nh*nh/15 && r<nh*nh/4) ||
								(type==8 && (i/nw!=nh/2 && (i/nw%3>0 || i%nw!=nw/2)|| i%nw!=nw/2 && (i%nw%3>0 || i/nw!=nh/2)))
						){
					nimg.setRGB(rnadIdx.get(i)%nw*size, rnadIdx.get(i)/nw*size, size, size, img.getRGB(i%nw*size, i/nw*size, size, size,  null, 0, size), 0, size);
					findBorder[i/nw][i%nw]=1;
					count++;
				}
				else {
					if(type==2)
						start++;
				}
				if(type==3 && i%nw%5==4)
					start++;
				if(type==3 && i%nw==nw-1)
					start=2;
			}
			for(int i=0;i<nh-1;i++)
				for(int j=0;j<nw;j++){
					if(findBorder[i][j]==1 && findBorder[i+1][j]==1)
						borderNum++;
				}
			for(int i=0;i<nh;i++)
				for(int j=0;j<nw-1;j++){
					if(findBorder[i][j]==1 && findBorder[i][j+1]==1)
						borderNum++;
				}
//			System.out.println("Parts Num: "+count);
			File outputfile = new File(outputFile);
			ImageIO.write(nimg, "png", outputfile);
		}

		public BufferedImage getOrignalIm(){
			return img;
		}

		public BufferedImage getGenIm(){
			return nimg;
		}

		public int getBorderNum(){
			return borderNum;
		}
	}

	private class LABVector {
		double vec[][];
		int l;

		public LABVector(double[][] _vec) {
			vec=_vec;
			l=vec.length;
		}
		
		public LABVector blur()
		{
			double vres[][]=new double[l][3];
			vres[0][0]=(vec[0][0]+vec[1][0])/2;
			vres[0][1]=(vec[0][1]+vec[1][1])/2;
			vres[0][2]=(vec[0][2]+vec[1][2])/2;
			for(int i=1;i<l-1;i++){
				vres[i][0]=(vec[i-1][0]+vec[i][0]+vec[i+1][0])/3;
				vres[i][1]=(vec[i-1][1]+vec[i][1]+vec[i+1][1])/3;
				vres[i][2]=(vec[i-1][2]+vec[i][2]+vec[i+1][2])/3;
			}
			vres[l-1][0]=(vec[l-2][0]+vec[l-1][0])/2;
			vres[l-1][1]=(vec[l-2][1]+vec[l-1][1])/2;
			vres[l-1][2]=(vec[l-2][2]+vec[l-1][2])/2;
			return new LABVector(vres);
		}
		
		public LABVector sub(LABVector v2)
		{
			double vres[][]=new double[l][3];
			for(int i=0;i<l;i++){
				vres[i][0]=vec[i][0]-v2.vec[i][0];
				vres[i][1]=vec[i][1]-v2.vec[i][1];
				vres[i][2]=vec[i][2]-v2.vec[i][2];
			}
			return new LABVector(vres);
		}
		
		public LABVector sub2(LABVector v2)
		{
			double vres[][]=new double[l][3];
			for(int i=0;i<l;i++){
				vres[i][0]=vec[i][0]-v2.vec[i][0];
				if(vres[i][0]>20)
					vres[i][0]=0;
				vres[i][1]=vec[i][1]-v2.vec[i][1];
				if(vres[i][1]>20)
					vres[i][1]=0;
				vres[i][2]=vec[i][2]-v2.vec[i][2];
				if(vres[i][2]>20)
					vres[i][2]=0;
			}
			return new LABVector(vres);
		}
		
		public LABVector add(LABVector v2)
		{
			double vres[][]=new double[l][3];
			for(int i=0;i<l;i++){
				vres[i][0]=vec[i][0]+v2.vec[i][0];
//				if(vres[i][0]<0)
//					vres[i][0]=0;
//				if(vres[i][0]>65535)
//					vres[i][0]=65535;
				vres[i][1]=vec[i][1]+v2.vec[i][1];
//				if(vres[i][1]<0)
//					vres[i][1]=0;
//				if(vres[i][1]>65535)
//					vres[i][1]=65535;
				vres[i][2]=vec[i][2]+v2.vec[i][2];
//				if(vres[i][2]<0)
//					vres[i][2]=0;
//				if(vres[i][1]>65535)
//					vres[i][1]=65535;
			}
			return new LABVector(vres);
		}
		
		public double sum()
		{
			double sum1=0,sum2=0,sum3=0;
			for(int i=0;i<l;i++){
				sum1+=vec[i][0];
				sum2+=vec[i][1];
				sum3+=vec[i][2];
			}
			return (sum1+sum2+sum3);//3*Math.max(sum1,sum2/2+sum3/2);
		}
		
		public double avgGrad()
		{
			double sum=0;
			for(int i=0;i<l-1;i++){
				sum+=Math.abs(vec[i][0]-vec[i+1][0]);
				sum+=Math.abs(vec[i][1]-vec[i+1][1]);
				sum+=Math.abs(vec[i][2]-vec[i+1][2]);
			}
			return sum/l/3;
		}

		public LABVector pow(double p)
		{
			double vres[][]=new double[l][3];
			for(int i=0;i<l;i++){
				vres[i][0]=Math.pow(vec[i][0],p);
				vres[i][1]=Math.pow(vec[i][1],p);
				vres[i][2]=Math.pow(vec[i][2],p);
			}
			return new LABVector(vres);
		}

		public LABVector abs()
		{
			double vres[][]=new double[l][3];
			for(int i=0;i<l;i++){
				vres[i][0]=Math.abs(vec[i][0]);
				vres[i][1]=Math.abs(vec[i][1]);
				vres[i][2]=Math.abs(vec[i][2]);
			}
			return new LABVector(vres);
		}
		
	}

	private enum Orientation {
		UP, DOWN, LEFT, RIGHT
	}
	
	private class PuzzlePart {
		int partSize, h, w;
		BufferedImage img;
		double imgArray[][][];
		ArrayList<LABVector> imgCols;
		ArrayList<LABVector>  imgRows;
		
		public PuzzlePart(BufferedImage _img) {
			img=_img;
			h=img.getHeight();
			w=img.getWidth();
			partSize=w;
			imgArray=new double[w][h][3];
			for(int i=0;i<w;i++){
				for(int j=0;j<h;j++){
					double lab[]=new double[3];
					int RGB=img.getRGB(j, i);
					Color c = new Color(RGB);
					int B=c.getBlue();
					int G=c.getGreen();
					int R=c.getRed();
					ConvColor.rgb2lab(R, G, B, lab);
					//ConvColor.rgb2lab(255, 255, 255, lab);
					imgArray[i][j][0]=lab[0];
					imgArray[i][j][1]=lab[1];
					imgArray[i][j][2]=lab[2];
				}
			}
			imgCols=new ArrayList<LABVector>();
			imgRows=new ArrayList<LABVector>();
			LABVector c0 = getColI(0);
			LABVector c1 = getColI(1);
			imgCols.add(c0.sub(c1).add(c0));
			imgCols.add(c0);
			imgCols.add(c1);
			LABVector r0 = getRowI(0);
			LABVector r1 = getRowI(1);
			imgRows.add(r0.sub(r1).add(r0));
			imgRows.add(r0);
			imgRows.add(r1);
			for(int i=2;i<partSize-2;i++){
				imgCols.add(getColI(i));
				imgRows.add(getRowI(i));
			}
			LABVector c26 = getColI(partSize-2);
			LABVector c27 = getColI(partSize-1);
			imgCols.add(c26);
			imgCols.add(c27);
			imgCols.add(c27.sub(c26).add(c27));
			LABVector r26 = getRowI(partSize-2);
			LABVector r27 = getRowI(partSize-1);
			imgRows.add(r26);
			imgRows.add(r27);
			imgRows.add(r27.sub(r26).add(r27));
		}
		
		public double[] getPixel(int x, int y){
			double pix[]=new double[3];
			pix[0]=imgArray[x][y][0];
			pix[1]=imgArray[x][y][1];
			pix[2]=imgArray[x][y][2];
			return pix;
		}
		
		public LABVector getColI(int x){
			double pixels[][]=new double[h][3];
			for(int i=0;i<h;i++){
				pixels[i][0]=imgArray[i][x][0];
				pixels[i][1]=imgArray[i][x][1];
				pixels[i][2]=imgArray[i][x][2];
			}
			return new LABVector(pixels);
		}
		
		public LABVector getCol(int x){
			return imgCols.get(x);
		}
		
		
		public LABVector getRowI(int y){
			double pixels[][]=new double[w][3];
			for(int i=0;i<h;i++){
				pixels[i][0]=imgArray[y][i][0];
				pixels[i][1]=imgArray[y][i][1];
				pixels[i][2]=imgArray[y][i][2];
			}
			return new LABVector(pixels);
		}
		
		public LABVector getRow(int y){
			return imgRows.get(y);
		}

	}

	private class PuzzleParts {

		int partSize, h, w, nh, nw,partsNum,missPartsNum,burnPartsNum,darkPartsNum,lowEntPartsNum;
		BufferedImage img;
		BufferedImage puzzlePartsRGB[];
		PuzzlePart puzzlePartsLAB[];
		Boolean isEmptyV[],isEmptyB[],isEmptyD[];
//		double entropy[];
		double avgBorder[][][];

		public PuzzleParts(BufferedImage _img,int _partSize) {
			partSize=_partSize;
			img=_img;
			h=img.getHeight();
			w=img.getWidth();
			nh=h/partSize;
			nw=w/partSize;
			partsNum=nh*nw;
			missPartsNum=0;
			burnPartsNum=0;
			darkPartsNum=0;
			lowEntPartsNum=0;
			puzzlePartsRGB=new BufferedImage[nh*nw];
			puzzlePartsLAB=new PuzzlePart[nh*nw];
			isEmptyV=new Boolean[partsNum];
			isEmptyB=new Boolean[partsNum];
			isEmptyD=new Boolean[partsNum];
//			entropy=new double[partsNum];
			avgBorder=new double[3][4][partsNum];
			createPuzzlePartsRGB();
			createPuzzlePartsLAB();
			findEmpty();
			findBurn();
			findDark();
			findB();
//			findEntropyA();
//			System.out.print("BLA");
			
		}
		
		private void findB() {
			for(int i=0;i<partsNum;i++){
				isEmptyB[i]=true;
			
				for(Orientation or:Orientation.values()){
					int B = 0;
					int G = 0;
					int R = 0;
					int jj;
					switch (or){
					case DOWN:
						for(int k=0;k<partSize;k++){
//							int RGB=puzzlePartsRGB[i].getRGB(k,partSize-1);
//							Color c = new Color(RGB);
							B+=puzzlePartsLAB[i].imgArray[partSize-1][k][0];
							G+=puzzlePartsLAB[i].imgArray[partSize-1][k][1];
							R+=puzzlePartsLAB[i].imgArray[partSize-1][k][2];
							avgBorder[0][or.ordinal()][i]=R/partSize;
							avgBorder[1][or.ordinal()][i]=G/partSize;
							avgBorder[2][or.ordinal()][i]=B/partSize;
						}
						break;
					case LEFT:
						for(int k=0;k<partSize;k++){
//							int RGB=puzzlePartsRGB[i].getRGB(0,k);
//							Color c = new Color(RGB);
							B+=puzzlePartsLAB[i].imgArray[k][0][0];
							G+=puzzlePartsLAB[i].imgArray[k][0][1];
							R+=puzzlePartsLAB[i].imgArray[k][0][2];
							avgBorder[0][or.ordinal()][i]=R/partSize;
							avgBorder[1][or.ordinal()][i]=G/partSize;
							avgBorder[2][or.ordinal()][i]=B/partSize;
						}
						break;
					case RIGHT:
						for(int k=0;k<partSize;k++){
//							int RGB=puzzlePartsRGB[i].getRGB(partSize-1,k);
//							Color c = new Color(RGB);
							B+=puzzlePartsLAB[i].imgArray[k][partSize-1][0];
							G+=puzzlePartsLAB[i].imgArray[k][partSize-1][1];
							R+=puzzlePartsLAB[i].imgArray[k][partSize-1][2];
							avgBorder[0][or.ordinal()][i]=R/partSize;
							avgBorder[1][or.ordinal()][i]=G/partSize;
							avgBorder[2][or.ordinal()][i]=B/partSize;
						}
						break;
					case UP:
						for(int k=0;k<partSize;k++){
//							int RGB=puzzlePartsRGB[i].getRGB(k,0);
//							Color c = new Color(RGB);
							B+=puzzlePartsLAB[i].imgArray[0][k][0];
							G+=puzzlePartsLAB[i].imgArray[0][k][1];
							R+=puzzlePartsLAB[i].imgArray[0][k][2];
							avgBorder[0][or.ordinal()][i]=R/partSize;
							avgBorder[1][or.ordinal()][i]=G/partSize;
							avgBorder[2][or.ordinal()][i]=B/partSize;
						}
						break;
					default:
						break;
					
					}
		

				}
			}
			
		}

		PuzzlePart[] getPuzzlesparts(){
			return puzzlePartsLAB;
		}
	//	
//		private void findEntropyA(){
//			for(int i=0;i<partsNum;i++){
//				entropy[i]=findEntropy(i);
////				System.out.println(entropy[i]);
//				if(entropy[i]<0.0000001/*0.000001*/)
//					lowEntPartsNum++;
//			}
//		}
		
//		private Double findEntropy(int i) {
//			BufferedImage pimg=puzzlePartsRGB[i];
//			int hist[]=find_hist(pimg,16);
//			Double res1=0.0,res2=0.0,res3=0.0;
//			for(int j=0;j<16;j++){
//				double h1=hist[j];
//				double h2=hist[j+16];
//				double h3=hist[j+32];
//				if(h1!=0) res1+=(-Math.log10(h1/partSize/partSize)*(h1/partSize/partSize));
//				if(h2!=0) res2+=(-Math.log10(h2/partSize/partSize)*(h2/partSize/partSize));
//				if(h3!=0) res3+=(-Math.log10(h3/partSize/partSize)*(h3/partSize/partSize));
//			}
//			return (res1+res2+res3)/3;
//		}

//		private int[] find_hist(BufferedImage pimg, int bins) {
//			int hist[]=new int[3*bins];
//			for(int i=0;i<bins;i++){
//				hist[i]=0;
//			}
	//
//			for(int i=0;i<partSize;i++){
//				for(int j=0;j<partSize;j++){
//					int RGB=pimg.getRGB(i, j);
//					Color c = new Color(RGB);
//					int B=c.getBlue();
//					hist[B/bins]++;
//					int G=c.getGreen();
//					hist[G/bins+bins]++;
//					int R=c.getRed();
//					hist[R/bins+2*bins]++;
//				}
//			}
//			return hist;
//		}
		
		private void findEmpty() {
			for(int i=0;i<partsNum;i++){
				isEmptyV[i]=true;
				int B = 0;
				int G = 0;
				int R = 0;
				for(int j=0;j<partSize;j++){
					for(int k=0;k<partSize;k++){
						int RGB=puzzlePartsRGB[i].getRGB(j, k);
						Color c = new Color(RGB);
						B=c.getBlue();
						G=c.getGreen();
						R=c.getRed();
						if(R>0 || G>0 || B>0){
							isEmptyV[i]=false;
							break;
						}
					}
					if(R>0 || G>0 || B>0){
						isEmptyV[i]=false;
						break;
					}
				}
				if(isEmptyV[i])
					missPartsNum++;
			}
		}
		
		private void findBurn() {
			for(int i=0;i<partsNum;i++){
				isEmptyB[i]=true;
				int B = 0;
				int G = 0;
				int R = 0;
				for(int j=0;j<partSize;j++){
					for(int k=0;k<partSize;k++){
						int RGB=puzzlePartsRGB[i].getRGB(j, k);
						Color c = new Color(RGB);
						B=c.getBlue();
						G=c.getGreen();
						R=c.getRed();
						if(R<252 || G<252 || B<252){
							isEmptyB[i]=false;
							break;
						}
					}
					if(R<254 || G<254 || B<254){
						isEmptyB[i]=false;
						break;
					}
				}
				if(isEmptyB[i])
					burnPartsNum++;
			}
		}
		
		private void findDark() {

			for(int i=0;i<partsNum;i++){
				isEmptyD[i]=true;
				int B = 0;
				int G = 0;
				int R = 0;
				for(int j=0;j<partSize;j++){
					for(int k=0;k<partSize;k++){
						int RGB=puzzlePartsRGB[i].getRGB(j, k);
						Color c = new Color(RGB);
						B=c.getBlue();
						G=c.getGreen();
						R=c.getRed();
						if(R>1 || G>1 || B>1){
							isEmptyD[i]=false;
							break;
						}
					}
					if(R>1 || G>1 || B>1){
						isEmptyD[i]=false;
						break;
					}
				}
				if(isEmptyD[i])
					darkPartsNum++;
			}
		}

		public boolean isEmpty(int i){
			return isEmptyV[i];
		}
		
		public boolean isDark(int i){
			if(i<0 || i>partsNum-1)
				return false;
			return isEmptyD[i];
		}
		
//		public boolean isLowEnt(int i){
//			return entropy[i]<0.0000001;
//		}	
	//	
//		public boolean isNLowEnt(int i){
//			return entropy[i]>0.0000001;
//		}
		

		public boolean isBurn(int i){
			if(i<0 || i>partsNum-1)
				return false;
			return isEmptyB[i];
		}


		private void createPuzzlePartsRGB() {
			for(int i=0;i<nh*nw;i++){
				BufferedImage nimg=new BufferedImage(partSize, partSize,BufferedImage.TYPE_INT_RGB);
				nimg.setRGB(0, 0, partSize, partSize, img.getRGB(i%nw*partSize, i/nw*partSize, partSize, partSize,  null, 0, partSize), 0, partSize);
				puzzlePartsRGB[i]=nimg;
			}

		}

		private void createPuzzlePartsLAB() {
			for(int i=0;i<nh*nw;i++){
				puzzlePartsLAB[i]=new PuzzlePart(puzzlePartsRGB[i]);
			}

		}

		public PuzzlePart getLABPart(int i){
			return puzzlePartsLAB[i];
		}

		public BufferedImage getRGBPart(int i){
			return puzzlePartsRGB[i];
		}

		public int getPartsNum(){
			return partsNum;
		}

		public int getMissPartsNum(){
			return missPartsNum;
		}
		

		public int getBurnPartsNum(){
			return burnPartsNum;
		}
		
		public int getDarkPartsNum(){
			return darkPartsNum;
		}
		
		public int getLowEntPartsNum(){
			return lowEntPartsNum;
		}

		public int hetH(){
			return nh;
		}

		public int hetW(){
			return nw;
		}
	}

	private class PuzzleSolver{
		PuzzleParts puzzleParts;
		float diffMatrix[][][];
		//	double diffMatrix2[][][];
		float confMatrix[][][];
		int bestBuddies[][];
		int bestBuddies2[][];
		int partSize, partsNum,missPartsNum,burnPartsNum,w,h,startPart,partsLeft,startPart21,startPart22,borderNum;
		BufferedImage img;
		//	ArrayList<HashMap<Integer,Double>> bestBuddiesTree;
		//	ArrayList<HashSet<Integer>> bestBuddiesTreeIn;
		HashMap<Integer, Integer[]> chosenParts;
		ArrayList<TreeMap<Double, Integer[]>> nextToPlace;
		int budddiesNumber[];
		BufferedImage nimg;
		Integer finalPlacement[][];
		String name;
		Date d1,d2,d3;
		Random rnd=new Random();


		boolean useSize,useSize2;
		int minX,maxX,minY,maxY;
		double scale;
		boolean missPart;



		public PuzzleSolver(BufferedImage _img,int _partSize, String _name, boolean _useSize ,boolean _missPart, int _borderNum){
			name=_name;


			useSize=_useSize;
			missPart=_missPart;
			borderNum=_borderNum;

			d1=new Date();
			puzzleParts=new PuzzleParts(_img, _partSize);
			partSize=_partSize;
			partsNum=puzzleParts.getPartsNum();
			missPartsNum=puzzleParts.getMissPartsNum();
			burnPartsNum=puzzleParts.getBurnPartsNum();
//			System.out.println("M: "+missPartsNum);
			h=puzzleParts.hetH();
			w=puzzleParts.hetW();
			diffMatrix=new float[4][partsNum][partsNum];
			//		diffMatrix2=new double[partsNum][partsNum][4];
			confMatrix=new float[4][partsNum][partsNum];
			bestBuddies=new int[partsNum][4];
			bestBuddies2=new int[partsNum][4];
			//		bestBuddies2=new int[partsNum][4];
			//		bestBuddiesTree=new ArrayList<HashMap<Integer,Double>>();
			//		bestBuddiesTreeIn=new ArrayList<HashSet<Integer>>();
			partsLeft=partsNum;
			budddiesNumber=new int[partsNum];
			chosenParts=new HashMap<Integer, Integer[]>();
			nextToPlace=new ArrayList<TreeMap<Double, Integer[]>>();
			for(int i=0;i<17;i++){
				//			bestBuddiesTree.add(new HashMap<Integer,Double>());
				//			bestBuddiesTreeIn.add(new HashSet<Integer>());
				nextToPlace.add(new TreeMap<Double, Integer[]>());
			}
			finalPlacement=new Integer[partsNum/2][partsNum/2];
			minX=partsNum/2;maxX=0;minY=partsNum/2;maxY=0;
			scale=672.0/partSize/puzzleParts.nw;
			run();
		}

		public void run() {
			calcDiffMatrix();
			Date d3=new Date();
			//		copyDiffMatrix();
			calcConfMatrix();
			predictSuccess();
			findBestStart(true);
			//		printBB();
			solvePuzzle();
			Date d2=new Date();
//			name=((d2.getTime()-d1.getTime())/1000.0)+name;
			createOutputImage(name,true);	
//			System.out.println("Time: "+(d2.getTime()-d1.getTime())/1000.0);
//			System.out.println("Init Time: "+(d3.getTime()-d1.getTime())/1000.0);
			calcDirectComp2();
			calcNeighborsComp2();
		}

		private void predictSuccess() {
			double count=0;
			for(Orientation or:Orientation.values()){
				int orN=(or.ordinal()==0)?(0):(1);
				int op=(orN%2==0)?(orN+1):(orN-1);
				for(int i=0;i<partsNum;i++){

				}
			}

		}

		private void printBB() {
			// TODO Auto-generated method stub
			File f=new File("BB.txt");
			try {
				BufferedWriter bf=new BufferedWriter(new FileWriter(f));
				for(int k=0;k<4;k++){
					bf.write(k+":");
					bf.newLine();
					for(int i=0;i<partsNum;i++){
						bf.write(i+":"+bestBuddies[i][k]);
						bf.newLine();
					}
					bf.newLine();
				}
				bf.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		//	private void copyDiffMatrix() {
		//		for(Orientation or:Orientation.values()){
		//			for(int i=0;i<partsNum;i++){
		//				for(int j=0;j<partsNum;j++){
		//					diffMatrix2[i][j][or.ordinal()]=diffMatrix[0][i][j][or.ordinal()];
		//				}
		//			}
		//		}
		//
		//	}

		private void calcDirectComp() {
			double sum=0;
			for(int j=minX;j<maxX+1;j++){
				for(int i=minY;i<maxY+1;i++){
					if((finalPlacement[i][j]!=null && finalPlacement[i][j]-1==j-minX+(i-minY)*puzzleParts.nw) ||
							(finalPlacement[i][j]!=null && puzzleParts.isBurn(finalPlacement[i][j]-1) && puzzleParts.isBurn(j-minX+(i-minY)*puzzleParts.nw))||
							(finalPlacement[i][j]!=null && puzzleParts.isDark(finalPlacement[i][j]-1) && puzzleParts.isDark(j-minX+(i-minY)*puzzleParts.nw)))
						sum++;
				}
			}
//			System.out.println("Direct Comp: "+(sum/partsNum));
		}

		private void calcDirectComp2() {
			double sum=0;
			Integer[] off = chosenParts.get(startPart);
			int xOff=partsNum/4-minX-(startPart-1)%puzzleParts.nw-1;
			int yOff=partsNum/4-minY-(startPart-1)/puzzleParts.nw;
//			System.out.println("Off: "+xOff+" "+yOff);
			for(int j=minX;j<maxX+1;j++){
				for(int i=minY;i<maxY+1;i++){
					if((finalPlacement[i][j]!=null && finalPlacement[i][j]-1==j-minX-xOff+(i-minY-yOff)*puzzleParts.nw))//s ||
//							(finalPlacement[i][j]!=null && puzzleParts.isBurn(finalPlacement[i][j]-1) && puzzleParts.isBurn(j-minX-xOff+(i-minY-yOff)*puzzleParts.nw))||
//							(finalPlacement[i][j]!=null && puzzleParts.isDark(finalPlacement[i][j]-1) && puzzleParts.isDark(j-minX-xOff+(i-minY-yOff)*puzzleParts.nw)))
						sum++;
//					else
//						System.out.println("i j: "+(finalPlacement[i][j]-1)+" "+(j-minX-xOff+(i-minY-yOff)*puzzleParts.nw));
				}
			}
			System.out.println("Direct Comparison: "+(sum/(partsNum-missPartsNum)));
		}

		private void calcNeighborsComp() {
			double sum=0;
			int nh=puzzleParts.nh, nw=puzzleParts.nw;
			for(int i=minY;i<maxY+1;i++){
				for(int j=minX;j<maxX+1;j++){
					if((finalPlacement[i][j]!=null && finalPlacement[i][j+1]!=null && (finalPlacement[i][j]-1)%nw<nw-1 && finalPlacement[i][j]==finalPlacement[i][j+1]-1)||
							((finalPlacement[i+1][j]!=null && finalPlacement[i][j]!=null && puzzleParts.isBurn(finalPlacement[i][j]-1)) || (finalPlacement[i][j]!=null && finalPlacement[i+1][j]!=null && puzzleParts.isBurn(finalPlacement[i+1][j]-1)))||
							(finalPlacement[i+1][j]!=null && finalPlacement[i][j]!=null && puzzleParts.isDark(finalPlacement[i][j]-1)) || (finalPlacement[i][j]!=null && finalPlacement[i+1][j]!=null && puzzleParts.isDark(finalPlacement[i+1][j]-1)))
						sum++;
					//				else
					//					System.out.println((finalPlacement[i][j]-1)+"*1"+finalPlacement[i][j+1]);
					if((finalPlacement[i][j]!=null && finalPlacement[i+1][j]!=null && (finalPlacement[i][j]-1)/nw<nh-1 && finalPlacement[i][j]-1+nw==finalPlacement[i+1][j]-1) ||
							(finalPlacement[i][j+1]!=null && finalPlacement[i][j]!=null && puzzleParts.isBurn(finalPlacement[i][j]-1) || (finalPlacement[i][j]!=null && finalPlacement[i][j+1]!=null && puzzleParts.isBurn(finalPlacement[i][j+1]-1)))||
							(finalPlacement[i][j+1]!=null && finalPlacement[i][j]!=null && puzzleParts.isDark(finalPlacement[i][j]-1))|| (finalPlacement[i][j]!=null && finalPlacement[i][j+1]!=null && puzzleParts.isDark(finalPlacement[i][j+1]-1)))
						sum++;
					//				else
					//					System.out.println((finalPlacement[i][j]-1)+"*2"+finalPlacement[i+1][j]);
				}
			}
//			System.out.println("Neighbors Comp: "+(sum/((nh-1)*(nw)+(nw-1)*(nh))));
		}

		private void calcNeighborsComp2() {
			double sum=0;
			int nh=puzzleParts.nh, nw=puzzleParts.nw;
			for(int i=minY;i<maxY+1;i++){
				for(int j=minX;j<maxX+1;j++){
					if((finalPlacement[i][j]!=null && finalPlacement[i][j+1]!=null && (finalPlacement[i][j]-1)%nw<nw-1 && finalPlacement[i][j]==finalPlacement[i][j+1]-1))
//							||((finalPlacement[i+1][j]!=null && finalPlacement[i][j]!=null && puzzleParts.isBurn(finalPlacement[i][j]-1)) || (finalPlacement[i][j]!=null && finalPlacement[i+1][j]!=null && puzzleParts.isBurn(finalPlacement[i+1][j]-1))))
						//					||
						//						(finalPlacement[i][j]!=null && puzzleParts.isDark(finalPlacement[i][j]-1)) || (finalPlacement[i+1][j]!=null && puzzleParts.isDark(finalPlacement[i+1][j]-1)))
						sum++;
					//				else
					//					System.out.println((finalPlacement[i][j]-1)+"*1"+finalPlacement[i][j+1]);
					if((finalPlacement[i][j]!=null && finalPlacement[i+1][j]!=null && (finalPlacement[i][j]-1)/nw<nh-1 && finalPlacement[i][j]-1+nw==finalPlacement[i+1][j]-1))
//							||(finalPlacement[i][j+1]!=null && finalPlacement[i][j]!=null && puzzleParts.isBurn(finalPlacement[i][j]-1) || (finalPlacement[i][j]!=null && finalPlacement[i][j+1]!=null && puzzleParts.isBurn(finalPlacement[i][j+1]-1))))
						//					||	(finalPlacement[i][j]!=null && puzzleParts.isDark(finalPlacement[i][j]-1)))
						sum++;
					//				else
					//					System.out.println((finalPlacement[i][j]-1)+"*2"+finalPlacement[i+1][j]);
				}
			}
			//		System.out.println("Neighbors Comp: "+(sum/(-missPartsNum*4+(nh-1)*(nw)+(nw-1)*(nh))));
			System.out.println("Neighbors Comparison: "+(sum/borderNum));
		}

		public Image getScaledImage(Image srcImg, int w, int h){
			BufferedImage resizedImg = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
			Graphics2D g2 = resizedImg.createGraphics();
			g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
			g2.drawImage(srcImg, 0, 0, w, h, null);
			g2.dispose();
			return resizedImg;
		}

		private void createOutputImage(String s, boolean save) {
			int borders[]=findBorder();
			nimg=new BufferedImage(partSize*(borders[3]-borders[2]+1), partSize*(borders[1]-borders[0]+1),BufferedImage.TYPE_INT_RGB);
			int offsety=partsNum/4-borders[0];
			int offsetx=partsNum/4-borders[2];
			Iterator<Integer> partsIt = chosenParts.keySet().iterator();
			while(partsIt.hasNext()){
				int part=partsIt.next();
				Integer[] place=chosenParts.get(part);
				nimg.setRGB(place[0]*partSize+partSize*offsetx, place[1]*partSize+partSize*offsety, partSize, partSize, puzzleParts.getRGBPart(part).getRGB(0, 0, partSize, partSize, null, 0, partSize), 0, partSize);
			}
			if(save){
				File outputfile = new File(s+".png");
				try {
					ImageIO.write(nimg, "png", outputfile);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

		private int[] findBorder() {
			int borders[]={partsNum/2, 0, partsNum/2, 0};
			//		int borders[]={minY,maxY,minX,maxX};
			for(int i=0;i<partsNum/2;i++){
				for(int j=0;j<partsNum/2;j++){
					if(finalPlacement[i][j]!=null){
						borders[1]=Math.max(borders[1], i);
						borders[0]=Math.min(borders[0], i);
						borders[3]=Math.max(borders[3], j);
						borders[2]=Math.min(borders[2], j);
					}
				}
			}
			return borders;
		}

		private void solvePuzzle() {
			int denum=10;
			if(burnPartsNum>10)
				denum=64;
			Integer base[]={0,0};
			chosenParts.put(startPart,base);
			finalPlacement[partsNum/4][partsNum/4]=startPart+1;
			maxX=Math.max(maxX, partsNum/4);
			minX=Math.min(minX, partsNum/4);
			maxY=Math.max(maxY, partsNum/4);
			minY=Math.min(minY, partsNum/4);
			partsLeft--;
			//		createOutputImage(Integer.toString(partsNum-partsLeft),true);
			addBuddies3(startPart);
			boolean forceBestBuddies=true;
			useSize2=useSize;
			double offset=0.0;
			int itNum=0,itF=0,itF2=0,itS=0;
			int ppartsLeft = partsLeft;
			int times=1;
//			missPartsNum=0;
			while(partsLeft-missPartsNum>0){
				int i;
				for(i=12;i>11;i--){
					//				System.out.println(s"S:"+nextToPlace.get(i).size());
					Iterator<Integer[]> best=nextToPlace.get(i).descendingMap().values().iterator();
													Iterator<Double> bestK=nextToPlace.get(i).descendingMap().keySet().iterator();
					if(!best.hasNext()) continue;
					Integer base2[]=new Integer[2];
					Integer[] nextI=best.next();
													Double key=bestK.next();
//									Double key=bestK.next();
					double flagc=0,flagc2=0;
					boolean flag=false;
					Double th = 0.0,th2 = 0.0;
					if(finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1][1]==nextI[0] && bestBuddies[nextI[0]][0]==finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1)) {
						flagc++;
						//					th+=confMatrix[finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1][nextI[0]][1]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1][0]/2;
					}
					//				if(finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4] !=null){
					//					th2+=confMatrix[finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1][nextI[0]][1]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1][0]/2;
					//					flagc2++;
					//				}
					if(finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1][0]==nextI[0] && bestBuddies[nextI[0]][1]==finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1)) {
						flagc++;
						//					th+=confMatrix[finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1][nextI[0]][0]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1][1]/2;
					}
					//				if(finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4] !=null){
					//					th2+=confMatrix[finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1][nextI[0]][0]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1][1]/2;
					//					flagc2++;
					//				}
					if(finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1][3]==nextI[0] && bestBuddies[nextI[0]][2]==finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1)) {
						flagc++;
						//					th+=confMatrix[finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1][nextI[0]][3]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1][2]/2;
					}
					//				if(finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4] !=null){
					//					th2+=confMatrix[finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1][nextI[0]][3]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1][2]/2;
					//					flagc2++;
					//				}
					if(finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1][2]==nextI[0] && bestBuddies[nextI[0]][3]==finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1)) {
						flagc++;
						//					th+=confMatrix[finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1][nextI[0]][2]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1][3]/2;
					}
					//				if(finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4] !=null){
					//					th2+=confMatrix[finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1][nextI[0]][2]/2+confMatrix[nextI[0]][finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1][3]/2;
					//					flagc2++;
					//				}
					//								if(forceBestBuddies && finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1][1]!=nextI[0] || bestBuddies[nextI[0]][0]!=finalPlacement[nextI[2]-1+partsNum/4][nextI[1]+partsNum/4]-1)) flag=true;
					//								if(forceBestBuddies && finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1][0]!=nextI[0] || bestBuddies[nextI[0]][1]!=finalPlacement[nextI[2]+1+partsNum/4][nextI[1]+partsNum/4]-1)) flag=true;
					//								if(forceBestBuddies && finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1][3]!=nextI[0] || bestBuddies[nextI[0]][2]!=finalPlacement[nextI[2]+partsNum/4][nextI[1]-1+partsNum/4]-1)) flag=true;
					//								if(forceBestBuddies && finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1][2]!=nextI[0] || bestBuddies[nextI[0]][3]!=finalPlacement[nextI[2]+partsNum/4][nextI[1]+1+partsNum/4]-1)) flag=true;
					//				double offset2=0.0;
					//								System.out.println(th);
					if(flagc==0) flag=true;
//									if(key<0.5) partsLeft=0;
					//				if(flagc==1 && th/flagc<0.4) flag=true;//0.371
					//				if(flagc==1 && th/flagc<0.11) flag=true;
					//				if(flagc2>2 && flagc<2) flag=true;
					//				if(flagc>1) flag=false;
					//				if(!forceBestBuddies && th2>0.366)  flag=false;
					if(!forceBestBuddies)  flag=false;
					if(chosenParts.containsKey(nextI[0])) 
						flag=true;
					base2[0]=nextI[1];
					base2[1]=nextI[2];
					if((useSize2 && (/*(puzzleParts.isBurn(nextI[0]) && puzzleParts.getBurnPartsNum()<partsLeft-10 )||*/
							/*(puzzleParts.isDark(nextI[0]) && puzzleParts.getDarkPartsNum()<partsLeft-5)||*/
							base2[0]+partsNum/4-minX+1>puzzleParts.nw || maxX-base2[0]-partsNum/4+1>puzzleParts.nw ||
							base2[1]+partsNum/4-minY+1>puzzleParts.nh || maxY-base2[1]-partsNum/4+1>puzzleParts.nh)))
						flag=true;
//					if(key<0.7 && forceBestBuddies) flag=true;
					if((finalPlacement[base2[1]+partsNum/4][base2[0]+partsNum/4])!=null /*|| (burnPartsNum<partsLeft && puzzleParts.isBurn(nextI[0]))*/ || flag ){
						nextToPlace.get(i).pollLastEntry();
						//					System.out.println("*part*: "+nextI[0]+"|| state: "+forceBestBuddies);
						break;
					}
					itF--;
					//				System.out.println("part: "+nextI[0]+"|| state: "+forceBestBuddies+" parts num: "+nextToPlace.get(12).size()+" | "+flagc+"/"+flagc2);
					//				if(partsLeft==partsNum/3 || partsLeft==2*partsNum/3){
					//				if(flagc==0){
					//					base2[0]=base2[0]-40*times;
					//					base2[1]=base2[1]-40*times;
					//					times++;
					//				}
					chosenParts.put(nextI[0],base2);
					finalPlacement[base2[1]+partsNum/4][base2[0]+partsNum/4]=nextI[0]+1;
					maxX=Math.max(maxX, base2[0]+partsNum/4);
					minX=Math.min(minX, base2[0]+partsNum/4);
					maxY=Math.max(maxY, base2[1]+partsNum/4);
					minY=Math.min(minY, base2[1]+partsNum/4);
					partsLeft--;
					//				createOutputImage(Integer.toString(partsNum-partsLeft),true);
					nextToPlace.get(i).pollLastEntry();
					addBuddies3(nextI[0]);
					if(!forceBestBuddies && partsNum/2>partsLeft)
						addBuddies2(nextI[0]);
//						System.out.println("***");
//					}
					
						
					if((!forceBestBuddies && (itF<1 || partsLeft>partsNum/2-1)) || missPart/*&& ((itF<30 && !useSize))*/){
						forceBestBuddies=true;
						//					clean();
					}
					break;
				}
				if(i==11) {
//					System.out.println("Check: "+partsLeft);
					eliminateComp();
					//				itF=1;
					if(ppartsLeft-ppartsLeft/5-1<partsLeft){
						//					itS++;
//						if((forceBestBuddies)){
							//						addCandidates(true);
//						}
//						else{

							addCandidates(false);

							//												break;
//						}
						forceBestBuddies=false;
						itF=Math.max(nextToPlace.get(12).size()*(partsNum-partsLeft)/partsNum/denum,1);
						if(partsNum/2>partsLeft)
							itF=partsLeft/2;
						if(missPart)
							itF=1;
						itS+=itF;
					}
					else
						addCandidates(true);
					//				if(itS>3 && partsLeft<partsNum/2 && !missPart)
					//					forceBestBuddies=false;
					itNum++;
					ppartsLeft=partsLeft;
//					System.out.println(forceBestBuddies+" s:"+nextToPlace.get(12).size());
					//				itF=1;//Math.max(nextToPlace.get(12).size()*(partsNum-partsLeft)/partsNum/denum,1);
					//				if(partsNum>5000 && partsLeft<partsNum/2)
					//					Math.max(nextToPlace.get(12).size()/denum,1);
					//				System.out.println("Can: " + itF);
					if(itNum>10000) break;
					//				break;
				}
				if(partsLeft-missPartsNum-burnPartsNum<1 && useSize && !useSize2){
					removeWraped();
					eliminateComp();
					addCandidates(true);
					forceBestBuddies=true;
					useSize2=true;
				}
			}
			//		cleanBad();
//			System.out.println("PrL: "+ (double)(itS-puzzleParts.burnPartsNum	-puzzleParts.darkPartsNum)/partsNum);
//			System.out.println("itNum: "+itNum+"# itS: "+itS);
//			System.out.println("RNum: "+partsLeft);
		}

		private void removeWraped() {
			int w=puzzleParts.nw,h=puzzleParts.nh;
			int yOff=maxY-minY+1-h+1;
			yOff=Math.max(1, yOff);
			int xOff=maxX-minX+1-w+1;
			xOff=Math.max(1, xOff);
//			System.out.println("Tmp: "+ xOff +":"+ yOff);
			TreeMap<Integer, Integer[]> op=new TreeMap<Integer, Integer[]>();
			for(int i=minY;i<minY+yOff;i++){
				for(int j=minX;j<minX+xOff;j++){
					Integer tmp[]={i,j};
					op.put(countParts(i,j,h,w), tmp);
				}
			}
			Integer res[]=op.descendingMap().values().iterator().next();
			removeParts(res[1],res[0],h,w);
			minX=res[1];
			maxX=minX+w-1;
			minY=res[0];
			maxY=minY+h-1;
			int border[]=findBorder();
			minY=border[0];maxY=border[1];
			minX=border[2];maxX=border[3];
		}

		private void removeParts(Integer x, Integer y, int h, int w) {
			for(int i=minY;i<maxY+1;i++){
				for(int j=minX;j<maxX+1;j++){
					if(finalPlacement[i][j]!=null &&(i<y || i>y+h-1 || j<x || j>x+w-1 || puzzleParts.isBurn(finalPlacement[i][j]-1))){
						chosenParts.remove(finalPlacement[i][j]-1);
						finalPlacement[i][j]=null;
						partsLeft++;
					}
				}
			}

		}

		private Integer countParts(int i, int j, int h, int w) {
			Integer count=0;
			for(int ii=0;ii<h;ii++){
				for(int jj=0;jj<w;jj++){
					if(finalPlacement[ii+i][jj+j]!=null)
						count++;
				}
			}
			//		System.out.println("C: "+count);
			return count;
		}

		private void cleanBad() {
			//		double avgD=avgDiff();
			//		for(int i=minY;i<maxY;i++){
			//			for(int j=minX;j<maxX;j++){
			//				boolean flag=false;
			//				if(finalPlacement[i][j]!=null){
			//					if(diffMatrix2[finalPlacement[i][j]-1][finalPlacement[i][j+1]-1][Orientation.RIGHT.ordinal()]<avgD*0.9)
			//						flag=true;
			//					if(diffMatrix2[finalPlacement[i][j]-1][finalPlacement[i+1][j]-1][Orientation.DOWN.ordinal()]<avgD*0.9)
			//						flag=true;
			//					if(flag){
			//						chosenParts.remove(finalPlacement[i][j]-1);
			//						finalPlacement[i][j]=null;
			//						partsLeft--;
			//					}
			//				}
			//			}
			//		}


		}

		//	private double avgDiff() {
		//		double avgD=0;
		//		int counter=0;
		//		for(int i=minY;i<maxY;i++){
		//			for(int j=minX;j<maxX;j++){
		//				if(finalPlacement[i][j]!=null){
		//					avgD+=diffMatrix2[finalPlacement[i][j]-1][finalPlacement[i][j+1]-1][Orientation.RIGHT.ordinal()];
		//					avgD+=diffMatrix2[finalPlacement[i][j]-1][finalPlacement[i+1][j]-1][Orientation.DOWN.ordinal()];
		//					avgD+=diffMatrix2[finalPlacement[i][j+1]-1][finalPlacement[i][j]-1][Orientation.LEFT.ordinal()];
		//					avgD+=diffMatrix2[finalPlacement[i+1][j]-1][finalPlacement[i][j]-1][Orientation.UP.ordinal()];
		//					counter+=2;
		//				}
		//			}
		//		}
		//		avgD/=counter;
		//		System.out.println("avgD: "+avgD/2);
		//		return avgD;
		//	}

		private void addCandidates(boolean flag) {
			if(maxX-minX>5){
				Thread[] threads = new Thread[maxY-minY+1];
				for(int i=0;i<maxY-minY+1;i++){
					threads[i]=new Thread(new AddCandidates(minX, maxX, minY, maxY, i+minY, partsNum, partsLeft, finalPlacement, chosenParts, nextToPlace, confMatrix, bestBuddies, flag, useSize2, budddiesNumber, puzzleParts,missPart,bestBuddies2));
					threads[i].start();

				}
				for(int i=0;i<maxY-minY+1;i++){
					try {
						threads[i].join();
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
			else{
				for(int i=minY;i<maxY+1;i++){

					for(int j=minX;j<maxX+1;j++){
						if(finalPlacement[i][j]!=null){
							if(finalPlacement[i-1][j]==null || finalPlacement[i+1][j]==null || finalPlacement[i][j-1]==null || finalPlacement[i][j+1]==null){
								if(flag)
									addBuddies(finalPlacement[i][j]-1);
								else
									addBuddies2(finalPlacement[i][j]-1);
							}
						}
					}
				}
			}
		}

		private void eliminateComp() {
			for(int i=0;i<partsNum;i++){
				for(int j=0;j<partsNum;j++){
					if(chosenParts.containsKey(i) && chosenParts.containsKey(j)){
						diffMatrix[0][i][j]=Float.MAX_VALUE;
						diffMatrix[1][i][j]=Float.MAX_VALUE;
						diffMatrix[2][i][j]=Float.MAX_VALUE;
						diffMatrix[3][i][j]=Float.MAX_VALUE;
						//					diffMatrix[1][i][j][0]=Double.MAX_VALUE;
						//					diffMatrix[1][i][j][1]=Double.MAX_VALUE;
						//					diffMatrix[1][i][j][2]=Double.MAX_VALUE;
						//					diffMatrix[1][i][j][3]=Double.MAX_VALUE;
					}
					else if(chosenParts.containsKey(j)){
						int nextA[]=new int[2];
						nextA[0]=chosenParts.get(j)[0];
						nextA[1]=chosenParts.get(j)[1];
						if(finalPlacement[nextA[1]-1+partsNum/4][nextA[0]+partsNum/4] != null)
							diffMatrix[1][i][j]=Float.MAX_VALUE;
						if(finalPlacement[nextA[1]+1+partsNum/4][nextA[0]+partsNum/4] != null)
							diffMatrix[0][i][j]=Float.MAX_VALUE;
						if(finalPlacement[nextA[1]+partsNum/4][nextA[0]+partsNum/4-1] != null)
							diffMatrix[3][i][j]=Float.MAX_VALUE;
						if(finalPlacement[nextA[1]+partsNum/4][nextA[0]+partsNum/4+1] != null)
							diffMatrix[2][i][j]=Float.MAX_VALUE;
						//					if(finalPlacement[nextA[1]-1+partsNum/4][nextA[0]+partsNum/4] != null &&
						//							finalPlacement[nextA[1]+1+partsNum/4][nextA[0]+partsNum/4] != null &&
						//							finalPlacement[nextA[1]+partsNum/4][nextA[0]+partsNum/4-1] != null &&
						//							finalPlacement[nextA[1]+partsNum/4][nextA[0]+partsNum/4+1] != null){				
						//						diffMatrix[0][i][j][1]=Double.MAX_VALUE;
						//						diffMatrix[0][i][j][0]=Double.MAX_VALUE;
						//						diffMatrix[0][i][j][3]=Double.MAX_VALUE;
						//						diffMatrix[0][i][j][2]=Double.MAX_VALUE;
						//					}

						//						diffMatrix[1][i][j][0]=Double.MAX_VALUE;
						//						diffMatrix[1][i][j][1]=Double.MAX_VALUE;
						//						diffMatrix[1][i][j][2]=Double.MAX_VALUE;
						//						diffMatrix[1][i][j][3]=Double.MAX_VALUE;

					}
					//				else{
					//					diffMatrix[0][i][j][0]=diffMatrix[0][i][j][0];
					//					diffMatrix[0][i][j][1]=diffMatrix[0][i][j][1];
					//					diffMatrix[0][i][j][2]=diffMatrix[0][i][j][2];
					//					diffMatrix[0][i][j][3]=diffMatrix[0][i][j][3];
					//				}
				}
			}
			calcConfMatrix();
			//clean();
			//findBestStart(false);
		}

		private void clean() {
			//		bestBuddiesTree=new ArrayList<HashMap<Integer,Double>>();
			nextToPlace=new ArrayList<TreeMap<Double, Integer[]>>();
			for(int i=0;i<17;i++){
				//			bestBuddiesTree.add(new HashMap<Integer,Double>());
				nextToPlace.add(new TreeMap<Double, Integer[]>());
			}
		}

		private void addBuddies(int nextI) {
			ArrayList<Orientation> ao=new ArrayList<Orientation>();
			ao.add(Orientation.DOWN);ao.add(Orientation.UP);ao.add(Orientation.LEFT);ao.add(Orientation.RIGHT);
			Collections.shuffle(ao);
			for(Orientation or:Orientation.values()){
				int next=bestBuddies[nextI][or.ordinal()];
				//			if(puzzleParts.isBurn(next) && partsLeft>puzzleParts.burnPartsNum+2)
				//				continue;
				if(next==-1)
					continue;
				int op=(or.ordinal()%2==0)?(or.ordinal()+1):(or.ordinal()-1);
				//			int count=-1;
				//			Double val=confMatrix[next][nextI][op];
				//			if(val>confMatrix[next][bestBuddies[next][0]][0])
				//				count++;
				//			if(val>confMatrix[next][bestBuddies[next][1]][1])
				//				count++;
				//			if(val>confMatrix[next][bestBuddies[next][2]][2])
				//				count++;
				//			if(val>confMatrix[next][bestBuddies[next][3]][3])
				//				count++;
				//			if(count>1)
				//				continue;
				Integer nextA[]=new Integer[3];
				nextA[0]=next;
				//			Double val=confMatrix[nextI][next][or.ordinal()]/2+confMatrix[next][nextI][op]/2;
				int dir[]=new int[3];
				if(nextI==bestBuddies[next][op]  && !chosenParts.containsKey(next)){ //&&
					//!nextToPlace.get(budddiesNumber[next]-1).containsKey(bestBuddiesTree.get(budddiesNumber[next]-1).get(next))){
					switch(or){
					case UP:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]-1;
						dir[0]=3;
						dir[1]=1;
						dir[2]=2;
						break;
					case DOWN:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]+1;
						dir[0]=2;
						dir[1]=0;
						dir[2]=3;
						break;
					case LEFT:
						nextA[1]=chosenParts.get(nextI)[0]-1;
						nextA[2]=chosenParts.get(nextI)[1];
						dir[0]=0;
						dir[1]=3;
						dir[2]=1;
						break;
					case RIGHT:
						nextA[1]=chosenParts.get(nextI)[0]+1;
						nextA[2]=chosenParts.get(nextI)[1];
						dir[0]=1;
						dir[1]=2;
						dir[2]=0;
						break;
					default:
						break;
					}
					if((useSize2 && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
							nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
						continue;
					//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]!=next || bestBuddies[next][0]!=finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1)) break;
					//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]!=next || bestBuddies[next][1]!=finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1)) break;
					//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]!=next || bestBuddies[next][2]!=finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1)) break;
					//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]!=next || bestBuddies[next][3]!=finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1)) break;
					int flagc=0;
					double w1=0.5,w2=0.5;
					//				if(partsLeft<partsNum/16){
					//					w1=0.25;
					//					w2=0.75;
					//				}
					//				Double val=0.0;
					//System.out.println(nextA[0]+" "+nextA[1]+" "+nextA[2]+" "+val);
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
						flagc++;                
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					} 
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
					    flagc++;
					}

					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][0]==finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null  && bestBuddies[nextA[0]][2]==finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1) {
					    flagc++;
					}   	
					double th2=0;
					int flagc2=0;
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[1][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[0][nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[0][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[1][nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
						th2+=w1*confMatrix[3][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]]+w2*confMatrix[2][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
						th2+=w1*confMatrix[2][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]]+w2*confMatrix[3][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1];
						flagc2++;
					}
					//				if(flagc2==1 && //partsNum-partsLeft>4 &&
					//						(bestBuddies[next][dir[0]]!=-1 && bestBuddies[bestBuddies[next][dir[0]]][dir[1]]!=-1
					//						&& bestBuddies[bestBuddies[bestBuddies[next][dir[0]]][dir[1]]][dir[2]]!=nextI) //&&
					//						(bestBuddies[next][dir[2]]!=-1 && bestBuddies[bestBuddies[next][dir[2]]][dir[1]]!=-1
					//						&& bestBuddies[bestBuddies[bestBuddies[next][dir[2]]][dir[1]]][dir[0]]!=nextI)						)
					//						)
					//					continue;
					double add=((flagc-1)>0)?(flagc-1):0;
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
						synchronized (nextToPlace){	
							if(!missPart)
								nextToPlace.get(12).put(th2/flagc2+flagc2*0.000+add*0.3,nextA);///flagc+(flagc-1)*0.08
							else
								nextToPlace.get(12).put(th2/flagc2,nextA);///flagc+(flagc-1)*0.08
						}
					}

					//				nextToPlace.get(budddiesNumber[next]).put(bestBuddiesTree.get(budddiesNumber[next]).get(next),nextA);
				}
			}
		}

		private void addBuddies2(int nextI) {
			ArrayList<Orientation> ao=new ArrayList<Orientation>();
			ao.add(Orientation.DOWN);ao.add(Orientation.UP);ao.add(Orientation.LEFT);ao.add(Orientation.RIGHT);
			Collections.shuffle(ao);
			for(Orientation or:Orientation.values()){
				int next=bestBuddies[nextI][or.ordinal()];
				//			if(puzzleParts.isBurn(next) && partsLeft>puzzleParts.burnPartsNum+2)
				//				continue;
				if(next==-1)
					continue;
				int op=(or.ordinal()%2==0)?(or.ordinal()+1):(or.ordinal()-1);
				//			int next2=bestBuddies[next][op];
				//			Double val=confMatrix[nextI][next][or.ordinal()]/2+confMatrix[next][nextI][op]/2;
				//			Double val=confMatrix[next][nextI][op];
				//			if(val<0.368) continue;
				//			int count=0;
				//			Double val=confMatrix[next][nextI][op];
				//			if(val<confMatrix[next][bestBuddies[next][0]][0])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][1]][1])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][2]][2])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][3]][3])
				//				count++;
				//			if(count>1)
				//				continue;
				Integer nextA[]=new Integer[3];
				nextA[0]=next;
				if(!chosenParts.containsKey(next)){ //&&
					switch(or){
					case UP:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]-1;
						break;
					case DOWN:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]+1;
						break;
					case LEFT:
						nextA[1]=chosenParts.get(nextI)[0]-1;
						nextA[2]=chosenParts.get(nextI)[1];
						break;
					case RIGHT:
						nextA[1]=chosenParts.get(nextI)[0]+1;
						nextA[2]=chosenParts.get(nextI)[1];
						break;
					default:
						break;
					}
					if((useSize2 && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
							nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
						continue;
					int flagc=0;
					double w1=0.5,w2=0.5;
					//				if(partsLeft<partsNum/16){
					//					w1=0.25;
					//					w2=0.75;
					//				}
					//				double val=0;
					//System.out.println(nextA[0]+" "+nextA[1]+" "+nextA[2]+" "+val);
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
						flagc++;                
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					} 
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
					    flagc++;
					}

					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][0]==finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null  && bestBuddies[nextA[0]][2]==finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1) {
					    flagc++;
					}   		
					double th2=0,maxTh=0;
					int flagc2=0;
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[1][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[0][nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][1]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][0]);
						flagc2++;
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[0][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[1][nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][0]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][1]);
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
						th2+=w1*confMatrix[3][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]]+w2*confMatrix[2][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]][3]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][2]);
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
						th2+=w1*confMatrix[2][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]]+w2*confMatrix[3][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1];
						//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]][2]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][3]);
						flagc2++;
					}
					double add=((flagc-1)>0)?(flagc-1):0;
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
						synchronized (nextToPlace){	
							if(!missPart)
								nextToPlace.get(12).put(th2/flagc2+flagc2*0.5+add*0.3,nextA);
							else
								nextToPlace.get(12).put(th2/flagc2/*+maxTh/2*/,nextA);
						}
					}
				}
				//			next=bestBuddies2[nextI][or.ordinal()];
				//			if(next==-1)
				//				continue;
				//			nextA=new Integer[3];
				//			nextA[0]=next;
				//			if(!chosenParts.containsKey(next)){ //&&
				//				switch(or){
				//				case UP:
				//					nextA[1]=chosenParts.get(nextI)[0];
				//					nextA[2]=chosenParts.get(nextI)[1]-1;
				//					break;
				//				case DOWN:
				//					nextA[1]=chosenParts.get(nextI)[0];
				//					nextA[2]=chosenParts.get(nextI)[1]+1;
				//					break;
				//				case LEFT:
				//					nextA[1]=chosenParts.get(nextI)[0]-1;
				//					nextA[2]=chosenParts.get(nextI)[1];
				//					break;
				//				case RIGHT:
				//					nextA[1]=chosenParts.get(nextI)[0]+1;
				//					nextA[2]=chosenParts.get(nextI)[1];
				//					break;
				//				default:
				//					break;
				//				}
				//				if((useSize && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
				//						nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
				//					continue;
				//				int flagc=0;
				//				double w1=0.5,w2=0.5;
				//				if(partsLeft<partsNum/4){
				//					w1=0.25;
				//					w2=0.75;
				//				}
				//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
				//					flagc++;
				//				}
				//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
				//					flagc++;
				//				}
				//
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null  && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
				//					flagc++;
				//				}			
				//				double th2=0,maxTh=0;
				//				int flagc2=0;
				//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][1]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][0];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][1]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][0]);
				//					flagc2++;
				//				}
				//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][0]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][1];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]][0]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][1]);
				//					flagc2++;
				//				}
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]][3]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][2];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]][3]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][2]);
				//					flagc2++;
				//				}
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
				//					th2+=w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]][2]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][3];
				//					maxTh=Math.max(maxTh,w1*confMatrix[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]][2]+w2*confMatrix[nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][3]);
				//					flagc2++;
				//				}
				//				double add=((flagc-2)>0)?(flagc-2):0;
				//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
				//					if(!missPart)
				//						try{
				//							nextToPlace.get(12).put(th2/flagc2+flagc2*0.000+add*0.005,nextA);
				//						}
				//					catch (Exception e) {
				//						System.out.println("E"+flagc2);
				//					}
				//					else
				//						nextToPlace.get(12).put(th2/flagc2/*+maxTh/2*/,nextA);
				//				}
				//			}
			}
		}

		private void addBuddies3(int nextI) {
			ArrayList<Orientation> ao=new ArrayList<Orientation>();
			ao.add(Orientation.DOWN);ao.add(Orientation.UP);ao.add(Orientation.LEFT);ao.add(Orientation.RIGHT);
			Collections.shuffle(ao);
			for(Orientation or:Orientation.values()){
				int next=bestBuddies[nextI][or.ordinal()];
				//			if(puzzleParts.isBurn(next) && partsLeft>puzzleParts.burnPartsNum+2)
				//				continue;
				if(next==-1)
					continue;
				int op=(or.ordinal()%2==0)?(or.ordinal()+1):(or.ordinal()-1);
				Integer nextA[]=new Integer[3];
				nextA[0]=next;
				//			Double val=confMatrix[nextI][next][or.ordinal()]/2+confMatrix[next][nextI][op]/2;
				int count=0;
				//			Float val=confMatrix[next][nextI][op];
				//			if(val<confMatrix[next][bestBuddies[next][0]][0])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][1]][1])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][2]][2])
				//				count++;
				//			if(val<confMatrix[next][bestBuddies[next][3]][3])
				//				count++;

				int dir[]=new int[3];
				Integer cN=null,cN2=null;
				if(nextI==bestBuddies[next][op]  && !chosenParts.containsKey(next)){ //&&
					//!nextToPlace.get(budddiesNumber[next]-1).containsKey(bestBuddiesTree.get(budddiesNumber[next]-1).get(next))){
					switch(or){
					case UP:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]-1;
						dir[0]=3;
						dir[1]=1;
						dir[2]=2;
						cN=finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4+1];
						cN2=finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4-1];
						break;
					case DOWN:
						nextA[1]=chosenParts.get(nextI)[0];
						nextA[2]=chosenParts.get(nextI)[1]+1;
						dir[0]=2;
						dir[1]=0;
						dir[2]=3;
						cN=finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4-1];
						cN2=finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4+1];
						break;
					case LEFT:
						nextA[1]=chosenParts.get(nextI)[0]-1;
						nextA[2]=chosenParts.get(nextI)[1];
						dir[0]=0;
						dir[1]=3;
						dir[2]=1;
						cN=finalPlacement[nextA[2]+partsNum/4-1][nextA[1]+partsNum/4];
						cN2=finalPlacement[nextA[2]+partsNum/4+1][nextA[1]+partsNum/4];
						break;
					case RIGHT:
						nextA[1]=chosenParts.get(nextI)[0]+1;
						nextA[2]=chosenParts.get(nextI)[1];
						dir[0]=1;
						dir[1]=2;
						dir[2]=0;
						cN=finalPlacement[nextA[2]+partsNum/4+1][nextA[1]+partsNum/4];
						cN2=finalPlacement[nextA[2]+partsNum/4-1][nextA[1]+partsNum/4];
						break;
					default:
						break;
					}
					if((useSize2 && (nextA[1]+partsNum/4-minX+1>puzzleParts.nw || maxX-nextA[1]-partsNum/4+1>puzzleParts.nw ||
							nextA[2]+partsNum/4-minY+1>puzzleParts.nh || maxY-nextA[2]-partsNum/4+1>puzzleParts.nh)))
						continue;
					//				if(nextA[1]>partsNum/2-2|| nextA[1]<0 ||
					//						nextA[0]>partsNum/2-2|| nextA[0]<0)
					//					continue;
					//				if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]!=next || bestBuddies[next][0]!=finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1)) break;
					//				if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]!=next || bestBuddies[next][1]!=finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1)) break;
					//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]!=next || bestBuddies[next][2]!=finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1)) break;
					//				if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && (bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]!=next || bestBuddies[next][3]!=finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1)) break;
					int flagc=0;
					double w1=0.5,w2=0.5;
					//				if(partsLeft<partsNum/16){
					//					w1=0.25;
					//					w2=0.75;
					//				}
					//				Double val=0.0;
					//System.out.println(nextA[0]+" "+nextA[1]+" "+nextA[2]+" "+val);
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][1]==nextA[0]) {
						flagc++;                
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][1]==finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					} 
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][3]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[nextA[0]][3]==finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1) {
					    flagc++;
					}

					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][0]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null && bestBuddies[nextA[0]][0]==finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null && bestBuddies[finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][2]==nextA[0]) {
					    flagc++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null  && bestBuddies[nextA[0]][2]==finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1) {
					    flagc++;
					}   			
					double th2=0;
					int flagc2=0;
					if(finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[1][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[0][nextA[0]][finalPlacement[nextA[2]-1+partsNum/4][nextA[1]+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4] !=null){
						th2+=w1*confMatrix[0][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1][nextA[0]]+w2*confMatrix[1][nextA[0]][finalPlacement[nextA[2]+1+partsNum/4][nextA[1]+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4] !=null){
						th2+=w1*confMatrix[3][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1][nextA[0]]+w2*confMatrix[2][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]-1+partsNum/4]-1];
						flagc2++;
					}
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4] !=null){
						th2+=w1*confMatrix[2][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1][nextA[0]]+w2*confMatrix[3][nextA[0]][finalPlacement[nextA[2]+partsNum/4][nextA[1]+1+partsNum/4]-1];
						flagc2++;
					}
					double bonus=0.0;
					//				if(flagc2==1)
					//					bonus=0.5;
					//				if(flagc2==1 &&
					//						(bestBuddies[next][dir[0]]!=-1 && bestBuddies[bestBuddies[next][dir[0]]][dir[1]]!=-1
					//						&& bestBuddies[bestBuddies[bestBuddies[next][dir[0]]][dir[1]]][dir[2]]!=nextI) &&
					//						(bestBuddies[next][dir[2]]!=-1 && bestBuddies[bestBuddies[next][dir[2]]][dir[1]]!=-1
					//						&& bestBuddies[bestBuddies[bestBuddies[next][dir[2]]][dir[1]]][dir[0]]!=nextI))
					//						)
					//					bonus=0;
					//				continue;
					if(flagc2==1 &&
							(bestBuddies[next][dir[0]]!=-1 && bestBuddies[bestBuddies[next][dir[0]]][dir[1]]!=-1
							&& bestBuddies[bestBuddies[bestBuddies[next][dir[0]]][dir[1]]][dir[2]]==nextI))
						bonus+=0.25;
					if(cN != null && flagc2==1 &&
							(bestBuddies[next][dir[0]]!=-1 && 
							bestBuddies[bestBuddies[next][dir[0]]][dir[1]]==cN))
						bonus+=0.25;
					if(flagc2==1 &&
							(bestBuddies[next][dir[2]]!=-1 && bestBuddies[bestBuddies[next][dir[2]]][dir[1]]!=-1
							&& bestBuddies[bestBuddies[bestBuddies[next][dir[2]]][dir[1]]][dir[0]]==nextI))
						bonus+=0.25;
					if(cN2 != null && flagc2==1 &&
							(bestBuddies[next][dir[0]]!=-1 && 
							bestBuddies[bestBuddies[next][dir[2]]][dir[1]]==cN2))
						bonus+=0.25;
					//				if(bonus<0.2 && count>2)
					//					continue;
					//				bonus-=count*0.03;
					//				System.out.println("S1:"+th2/flagc2);
					double add=((flagc-2)>0)?(flagc-2):0;
					double add2=((flagc2-2)>0)?(flagc2-2):0;
					if(finalPlacement[nextA[2]+partsNum/4][nextA[1]+partsNum/4]==null){
						synchronized (nextToPlace){	
							if(!missPart)
								nextToPlace.get(12).put(th2/flagc2+add2*0.3+add*0.3+bonus,nextA);///flagc+(flagc-1)*0.08
							else
								nextToPlace.get(12).put(th2/flagc2+bonus + add*0.2,nextA);///flagc+(flagc-1)*0.08
						}
					}
					//				nextToPlace.get(budddiesNumber[next]).put(bestBuddiesTree.get(budddiesNumber[next]).get(next),nextA);
				}
			}
		}

		private void findBestStart(boolean first) {
			TreeMap<Double,Integer> tm=new TreeMap<Double,Integer>();
			//		TreeMap<Double,Integer> tm2=new TreeMap<Double,Integer>();
			double count=0,TP=0;
			int nh=puzzleParts.nh, nw=puzzleParts.nw;
			for(int i=0;i<partsNum;i++){
				budddiesNumber[i]=0;
				Double avgConf=0.0;
				for(int or=0;or<4;or++){
					int op=(or%2==0)?(or+1):(or-1);
					if(bestBuddies[i][or]==-1)
						continue;
					avgConf+=confMatrix[or][i][bestBuddies[i][or]]/2+confMatrix[op][bestBuddies[i][or]][i]/2;
					if(i==bestBuddies[bestBuddies[i][or]][op]) {
						budddiesNumber[i]+=25;
						count++;
						switch (or){
						case 0:
							if(i-nw==bestBuddies[i][or])
								TP++;
							break;
						case 1:
							if(i+nw==bestBuddies[i][or])
								TP++;
							break;
						case 2:
							if(i-1==bestBuddies[i][or])
								TP++;
							break;
						case 3:
							if(i+1==bestBuddies[i][or])
								TP++;
							break;

						}
					}
					if(bestBuddies[bestBuddies[i][or]][or]==-1)
						continue;
					if(first && bestBuddies[i][or]>-1 && bestBuddies[bestBuddies[i][or]][or]>-1 && bestBuddies[i][or]==bestBuddies[bestBuddies[bestBuddies[i][or]][or]][op]) budddiesNumber[i]+=5;
					if(first && bestBuddies[i][or]>-1 && bestBuddies[bestBuddies[i][or]][or]>-1 && bestBuddies[bestBuddies[bestBuddies[i][or]][or]][or]>-1 && bestBuddies[bestBuddies[i][or]][or]==bestBuddies[bestBuddies[bestBuddies[bestBuddies[i][or]][or]][or]][op]) budddiesNumber[i]++;
				}
				avgConf/=4;
				if(
						bestBuddies[bestBuddies[bestBuddies[bestBuddies[i][0]][3]][1]][2]==i &&
						bestBuddies[bestBuddies[bestBuddies[bestBuddies[i][3]][1]][2]][0]==i &&
						bestBuddies[bestBuddies[bestBuddies[bestBuddies[i][1]][2]][0]][3]==i &&
						bestBuddies[bestBuddies[bestBuddies[bestBuddies[i][2]][0]][3]][1]==i 
						){
					if(budddiesNumber[i]>119) {

						//				Double e=0.2*findEntropy(i)+0.2*findEntropy(bestBuddies[i][0])+0.2*findEntropy(bestBuddies[i][1])+
						//						0.2*findEntropy(bestBuddies[i][2])+0.2*findEntropy(bestBuddies[i][3]);
						tm.put(4*avgConf,i);//e+
					}
					//				count++;
				}
				//if(budddiesNumber[i]-1>0){
				//bestBuddiesTree.get(budddiesNumber[i]).put(i,avgConf);	
				//}
			}
//			System.out.println("Pr: "+(count+4*puzzleParts.burnPartsNum+4*puzzleParts.darkPartsNum)/((nh-1)*(nw)+(nw-1)*(nh))/2);
//			System.out.println("Pr: "+(count)/((nh-1)*(nw)+(nw-1)*(nh))/2);
//			System.out.println("BB: "+count/2+" TP: "+TP/2+" NOB: "+((nh-1)*(nw)+(nw-1)*(nh)));
			if(first){
				Iterator<Integer> ordIt=tm.descendingMap().values().iterator();
				if(ordIt.hasNext())
					startPart=ordIt.next();
//				startPart=1;
			}
		}

		private Double findEntropy(int i) {
			BufferedImage pimg=puzzleParts.getRGBPart(i);
			int hist[]=find_hist(pimg,16);
			Double res1=0.0,res2=0.0,res3=0.0;
			for(int j=0;j<16;j++){
				double h1=hist[j];
				double h2=hist[j+16];
				double h3=hist[j+32];
				if(h1!=0) res1+=(-Math.log10(h1/partSize/partSize)*(h1/partSize/partSize));
				if(h2!=0) res2+=(-Math.log10(h2/partSize/partSize)*(h2/partSize/partSize));
				if(h3!=0) res3+=(-Math.log10(h3/partSize/partSize)*(h3/partSize/partSize));
			}
			return (res1+res2+res3)/3;
		}

		private int[] find_hist(BufferedImage pimg, int bins) {
			int hist[]=new int[3*bins];
			for(int i=0;i<bins;i++){
				hist[i]=0;
			}

			for(int i=0;i<partSize;i++){
				for(int j=0;j<partSize;j++){
					int RGB=pimg.getRGB(i, j);
					Color c = new Color(RGB);
					int B=c.getBlue();
					hist[B/bins]++;
					int G=c.getGreen();
					hist[G/bins+bins]++;
					int R=c.getRed();
					hist[R/bins+2*bins]++;
				}
			}
			return hist;
		}

		private void calcConfMatrix() {
			Thread[] threads = new Thread[4];
			for(Orientation or:Orientation.values()){
				threads[or.ordinal()]=new Thread(new CalcConfMatrix(diffMatrix, confMatrix, bestBuddies, partSize, partsNum, partsLeft-missPartsNum, or,puzzleParts,missPart,chosenParts,bestBuddies2));
				threads[or.ordinal()].start();

			}

			for(Orientation or:Orientation.values()){

				try {
					threads[or.ordinal()].join();
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}
		}


		private void calcDiffMatrix() {
			Orientation arr[]=new Orientation[2];
			arr[0]=Orientation.values()[0];
			arr[1]=Orientation.values()[2];
			int thNum=4;//partsNum/400;//partsNum/(partsNum/500+1);
			int itNum=partsNum/thNum;
			Thread[] threads=new Thread[2*thNum*thNum+thNum+1];
			//		System.out.println("THNUM:"+thNum+" || Jump:"+itNum);
			//		threads = new Thread[2*2*partsNum];
			for(Orientation or:arr){
				int num=(or.ordinal()==0)?(0):(1);
				for(int i=0;i<partsNum;i+=itNum){
					for(int j=0;j<partsNum;j+=itNum){
						threads[num*thNum*thNum+i/itNum*thNum+j/itNum]=new Thread(new CalcDiff(diffMatrix,partSize,partsNum, puzzleParts, or, i,j,itNum));
						//				threads[2*num*partsNum+2*i+1]=new Thread(new CalcDiff(diffMatrix,partSize,partsNum, puzzleParts, or, i,1,0));
						threads[num*thNum*thNum+i/itNum*thNum+j/itNum].start();
						//				threads[2*num*partsNum+2*i+1].start();

					}
				}
			}

			for(Orientation or:arr){
				int num=(or.ordinal()==0)?(0):(1);
				for(int i=0;i<partsNum;i+=itNum){
					for(int j=0;j<partsNum;j+=itNum){
						try {
							threads[num*thNum*thNum+i/itNum*thNum+j/itNum].join();
							//					threads[2*num*partsNum+2*i+1].join();
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
				}
			}
		}
	}

	
	GeneratePuzzle gp;
	String inputFile;
	boolean useSize;
	boolean randomizePieces;


	public RunPuzzleSolver(String _inputFile, boolean _useSize, boolean _randomizePieces) {
		inputFile=_inputFile;
		useSize=_useSize;
		randomizePieces=_randomizePieces;
		run();
	}


	public void run() {


		String[] inputs = new String[1];
		inputs[0]=inputFile;
//		int jjj=0;
		for(String input:inputs){
			String inputSplit[]=input.split("\\.");
			try{
				gp=new GeneratePuzzle(input,inputSplit[0]+"_shuffled"+"."+inputSplit[1], 28,randomizePieces,0);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			System.out.println("Image: "+input);
//			Thread run=new Thread(new PuzzleSolver(gp.getGenIm(),28,inputSplit[0]+"_res",true,false));
//			run.start();
//			if(jjj<3)
				new PuzzleSolver(gp.getGenIm(),28,inputSplit[0]+"_res", useSize,false,gp.getBorderNum());
//			if(jjj>0)
//				new PuzzleSolver(gp.getGenIm(),28,inputSplit[0]+"_res",false,false,gp.getBorderNum());
//			try {
//				run.join();
//			} catch (InterruptedException e1) {
//				// TODO Auto-generated catch block
//				e1.printStackTrace();
//			}
			System.out.println("------------------------------------------------");
//			jjj++;
		}
		System.exit(0);

	}


//	public static void main(String[] args) {
//		new RunPuzzleSolver();
//	}

}
